#include "rc_def.h"
#include "comhead.h"
#pragma hdrstop

// m_arscan.cpp
// (C) 1993,95 by Heiko Damerow MPG AG "Roentgenbeugung"
// (C) 1996 by Heiko Damerow DLR
// modul for execution of area scan's with psd and sld

//! kommentiert von Diffr.gruppe (S. Berndt, J. Ullrich)

//! Kommentierung und Aenderungen B. Buss, 2000/2001, HUB IfI
//! speziell cm_dataaquisition, getthetaoffset(), setranges() ...


#include "m_devcom.h"
#include "m_layer.h"
#include "m_steerg.h"
#include "m_dlg.h"
#include "m_xscan.h"
#include "c_layer.h"

extern TMain Main;
extern LPDList lpDList;
extern LPDataBase lpDBase;
extern TSteering Steering;
extern TModelessDlg* TheModeless;

//! Fehlermeldungen
//! FIX Fehler 73
#ifdef GermanVersion
char szMsgFailure[] = "Fehler";
char szMessage[] = "Meldung";
char szMsgLine001[] = "Messung! Omega: %s 2Theta: %s Intensitt: %%.3f";
char szMsgLine002[] = "Der Detektor %s ist als Monitor gekennzeichnet!";
char szMsgLine003[] =
    "Starte Omega/2Theta-Scan(PSD)\n mit Omega von %s bis %s ?";
char szMsgLine004[] =
	 "Starte Omega/2Theta-Scan(SLD)\n mit Omega von %s bis %s ?";
char szMsgLine005[] = "Starte OmegaScan(PSD)\n mit Omega von %s bis %s ?";
char szMsgLine006[] = "Theta ist relativ!\n Relativen Winkel auslassen?";
char szMsgLine007[] = "Omega ist relativ!\n Relativen Winkel auslassen ?";
char szMsgLine008[] = "Scan-Nummer bersteigt %d !";
char szMsgLine009[] = "Messung! Omega:%s";
char szMsgLine010[] = "%s P(%s<>%%.1f) Integral Intensitt: %%.1f > %%d";
char szMsgLine011[] = "%d Scan's wurden gemessen";
char szMsgLine012[] = "Die Messung wurde abgeschlossen\r\n und gespeichert";
char szMsgLine013[] = "Messung wurde unterbrochen !";
char szMsgLine014[] = "Inkorrekter Header.";
char szMsgLine015[] = "Kein gltiger Scantyp";
char szMsgLine016[] = "Kein Detektor als Monitor spezifiziert!";
//! neu eingefuehrt
char szMsgLine017[] = "Bitte erst Daueranzeige deaktivieren!";
char szMsgLine018[] = "Die Messung wurde abgeschlossen";
char szMsgLine019[] = "Die Messung wurde abgeschlossen.\r\nFehler beim Speichern!";
char szMsgLine020[] = "Es ist ein Fehler aufgetreten. %d";
char szMsgLine021[] = "Hardware ist nicht vollstndig verfgbar !";
char szMsgLine022[] = "Vorgang bitte wiederholen !";
char szMsgLine023[] = "Kein gueltiger Darstellungstyp !";
char szMsgLine024[] = "Kein Psd verfgbar .";
char szMsgLine025[] = "Standard-Scan nur mit PSD";
char szMsgLine026[] = "Anzeige Psd-Spektrum ...";
char szMsgLine027[] = "Bitte die Darstellung >Curve< waehlen. ";
char szMsgLine028[] = "Scan %d von %d schreiben.";
char szMsgLine029[] = "Scan %d schreiben.";
#else
char szMsgFailure[] = "Failure";
char szMessage[] = "Message";
char szMsgLine001[] = "Measurement! Omega: %s 2Theta: %s Intensity: %%.3f";
char szMsgLine002[] = "The Device %s is tagged as Monitor !";
char szMsgLine003[] =
	 "Starting Omega/2Theta-Scan(PSD)\nwith Omega from %s to %s ?";
char szMsgLine004[] =
	 "Starting Omega/2Theta-Scan(SLD)\nwith Omega from %s to %s ?";
char szMsgLine005[] = "Starting OmegaScan(PSD)\nwith Omega from %s to %s ?";
char szMsgLine006[] = "Theta is relative!\nSkip relative Angle ?";
char szMsgLine007[] = "Omega is relative !\nSkip relative Angle ?";
char szMsgLine008[] = "Scan-Number exceeds %d !";
char szMsgLine009[] = "Measurement! Omega:%s";
char szMsgLine010[] = "%s P(%s<>%%.1f) Integral Intensity: %%.1f > %%d";
char szMsgLine011[] = "%d Scan's has been measured";
char szMsgLine012[] = "The Measurement is completed\r\nand the data were saved.";
char szMsgLine013[] = "Measurement has been interrupted !";
char szMsgLine014[] = "Incorrect Header.";
char szMsgLine015[] = "No valid Scan Type";
char szMsgLine016[] = "No Device as Monitor specified!";
//! neu eingefuehrt
char szMsgLine017[] = "Please deactivate Continuousdisplay first";
char szMsgLine018[] = "The Measurement is completed.";
char szMsgLine019[] = "The Measurement is completed.\r\nFailure on saving data.";
char szMsgLine020[] = "There is a Failure appeared. %d";
char szMsgLine021[] = "Hardware is not complete available !";
char szMsgLine022[] = "Please repeat the procedure !";
char szMsgLine023[] = "No valid Display Type !";
char szMsgLine024[] = "No psd available .";
char szMsgLine025[] = "Standard-Scan with PSD only";
char szMsgLine026[] = "Display psd-spectrum ...";
char szMsgLine027[] = "Please choose the Display-type >Curve< .";
char szMsgLine028[] = "Save Scan %d of %d .";
char szMsgLine029[] = "Save Scan %d .";

#endif

char aTempPath[ 120 ] = {0};
char aTempName[ 12 ] = {0};

// variables for data aquisition
typedef struct
{
    double dX, dY, dOmega, dTheta;
    float fDelta, fIntensity;
}
TData;

static int nLinePoints = 100;
static int nEnvironment = 0;
static char DataFile[ 40 ];
float PointX[ 2 ], PointY[ 2 ];
int nMouseAction = 0;
static TData* lpData;
static BOOL bAquisitionActive = FALSE;
static int nSetMarker = 0;
static BOOL bSetDXZero = FALSE;
static BOOL bSetDYZero = FALSE;
static BOOL bSetRLSave = FALSE;

static int nFirstReadColumn = 0;
static int nLastReadColumn = 0;

static float fPsdRange;
static char szODF[ 7 ], szOWF[ 7 ], szTDF[ 7 ], szTWF[ 7 ];
static TUnitType eThetaUnitType = Grad;

// #define DEBUG
// #define OldVersion
// #ifdef Peak_and_Cross


//! bestimmt 3 Integerwerte zwischen -9 und 9 aus einem String
//! wird nur in Verbindung mit Orientation,Reflection benutzt
//! 1.Parameter(ausgabe) Struktur von 3 integerwerten
//! 2.Parameter(eingabe) String
void SetHKL( THKL& refl, LPCSTR info )
{
    int i;
    THKL nr;

    i = 0;
    while ( '[' == info[ i ] ) i++;
    while ( ' ' == info[ i ] ) i++;
    if ( '-' == info[ i ] )
        nr.h = max( '0' - info[ ++i ], -9 );
    else
        nr.h = min( info[ i ] - '0', 9 );
    if ( '-' == info[ ++i ] )
        nr.k = max( '0' - info[ ++i ], -9 );
    else
        nr.k = min( info[ i ] - '0', 9 );
    if ( '-' == info[ ++i ] )
        nr.l = max( '0' - info[ ++i ], -9 );
    else
        nr.l = min( info[ i ] - '0', 9 );
    refl = nr;
};


//! bildet aus 3 Integerwerten einen String
//! wird nur in Verbindung mit Orientation,Reflection benutzt
//! 1.Parameter(eingabe) Struktur von 3 integerwerten
//! 2.Parameter(ausgabe) String
void GetHKL( THKL& refl, LPSTR info )
{
    sprintf( info, "[%d%d%d]", refl.h, refl.k, refl.l );
};


//*****************************************************************************
//********** Klasse TAreaScan **************************************
//*****************************************************************************

//! einlesen der Ini-daten zu [AreaScan] und
//! setzen von default-werten fuer AreaScan
//! wird nur durch TAreaScan-konstruktor aufgerufen
TAreaScanParameters::TAreaScanParameters()
{
    char Ident[] = "AreaScan";
    char buf[ MaxString ];
    double dDistance;
    int nOldId = mlGetAxis();

    //! setzen von Defaultwerten
    strcpy( ::DataFile, "*.dtn" );
    eScanType = Omega2ThetaScan;
    SetDevice( dlGetIdByName( PsdDevice ) );
    nAddedChannels = Device->GetAddedChannels();
    bThetaAddsPsd = TRUE;
    fMaxTime = 6.0;
    dwMaxCounts = 30000l;
    fFailure = 0.02;
    eSaveFormat = StandardFile;
    bSaveOnReady = FALSE;
    dMoveRelation = 2.0;
    dThetaOffset = 0.0;
    nOmega = mlGetIdByName( Omega );
    nTheta = mlGetIdByName( Theta );
    bAbsorberUsed = FALSE;
    //! Omegamotor und zugehoerige Werte setzen
    mlSetAxis( nOmega );
	 dOmegaWidth = mGetValue( Width );
    if ( !mGetDistance( dDistance ) )
    {
        dOmegaMin = 40.0;
        dOmegaMax = 46.0;
    }
    else
    {
        dOmegaMin = dDistance;
        dOmegaMax = dDistance + 4.0;
    }
    //! Thetamotor und zughoerige Werte setzen
    mlSetAxis( nTheta );
    dThetaWidth = dMoveRelation * dOmegaWidth;
	 dThetaMin = dMoveRelation * dOmegaMin;
    dThetaMax = dMoveRelation * dOmegaMax;
    dThetaWindow = dThetaMax - dThetaMin;
    //! einlesen der Daten aus dem [AreaScan]-Abschnitt des Ini-Files
    GetPrivateProfileString( Ident, "ExposureTime", "1.0", buf, MaxString,
                             GetCFile() );
    if ( CreateDefaults() )
        WritePrivateProfileString( Ident, "ExposureTime", buf, GetCFile() );
    fMaxTime = atof( buf );
    //! FIX Fehler 37
    bSaveOnReady = GetPrivateProfileInt(Ident, "SaveOnReady", 1, GetCFile() );
    //! FIX Fehler 56
    eNotifyValue = IntegralIntensity;
    //! auskommentiert von s.berndt j.ullrich
    //! mit physikern noch zu klaeren, ob ganz entfernen oder aenderungswunsch
    /* GetPrivateProfileString( Ident, "Report", "Integral", buf, MaxString,
                             GetCFile() );
    strupr( buf );
    //! festlegen, welche Informationen neben dem Omegawinkel und dem Thetawinkel
    //! als 3. wert im Scanreport gespeichert werden soll
    while ( 1 )
    {
        eNotifyValue = PeakPosition;
        if ( !strcmp( buf, "MONITOR" ) )
        {
            eNotifyValue = MonitorIntensity;
            if ( !dlIsDeviceValid( MonitorDevice ) )
            {
					 MessageBox( GetFocus(), szMsgLine016, szMessage, MBINFO );
                break;
            }
            Monitor = lpDList->DP( dlGetIdByName( MonitorDevice ) );
            break;
        }
        if ( !strcmp( buf, "ABSORBER" ) )
        {
            eNotifyValue = AbsorberPosition;
            break;
        }
        if ( !strcmp( buf, "INTEGRAL" ) )
        {
            eNotifyValue = IntegralIntensity;
				break;
        }
        if ( !strcmp( buf, "TIME" ) )
        {
            eNotifyValue = MeasurementTime;
            break;
        }
        if ( !strcmp( buf, "PEAK" ) )
        {
            eNotifyValue = PeakPosition;
            break;
        }
        break;
    }  */
    //! ermittelt Einheit des Thetamotors und Winkelwert eines Kanals + setzt den
    //! Motor , der zu Begin der Funktion gesetzt war
    mlSetAxis( nTheta );
    eThetaUnitType = mGetUnitType();
    ::fPsdRange = Device->GetAngleRange( eThetaUnitType );
    mlSetAxis( nOldId );
};


//! setzt den Detektor, dessen id-nummer dem Param. id entspricht
//! dabei wird bPsdDevice gesetzt, wenn der Detektor ein Psd ist
void TAreaScanParameters::SetDevice( int id )
{
    Device = lpDList->DP( id );
    bPsdDevice = ( Device->GetId() == dlGetIdByName( PsdDevice ) );
};
//#############################################################################

//! registr. des ScanFensters und das ScanFensterMenue erstellen
//! setzen von weiteren Defaultwerten
TAreaScan::TAreaScan( void )
{
    HMENU hMAdd;

	 bInterrupted = FALSE;
    bMacroRunning = FALSE;
    bCalibrationActive = FALSE;
    bShowPsdContinuous = FALSE;
    bSaveContinuous = FALSE;
    bThetaScanCompleted = FALSE;
    LowerBound = 0.5;
    UpperBound = 800.0;
    // Registrieren der Kindfenster-Klasse
    TMDIWindow::RegisterWnd();
    WindowType = W_PSDWindow;
    bMeasurementActive = FALSE;
    //! erstellen der menueeintraege des Areascanfensters
    TheMenu = CreatePopupMenu();
#ifdef GermanVersion
    AppendMenu( TheMenu, MF_STRING, cm_SetupAreaScan, "Setup zu&m AreaScan..." );
    AppendMenu( TheMenu, MF_STRING, cm_ShowCurveParam, "Darstellungs-&Optionen..."
              );
    AppendMenu( TheMenu, MF_STRING, cm_InitializeAreaScan, "&AreaScan starten" );
    AppendMenu( TheMenu, MF_SEPARATOR, 0, NULL );
    AppendMenu( TheMenu, MF_STRING, cm_ShowPsdP_Data, "&Impuls-Spektrum anzeigen" );
    AppendMenu( TheMenu, MF_STRING, cm_PSDRemoteSyncCtl,
                "Messung extern synchronisieren.." );
    AppendMenu( TheMenu, MF_STRING, cm_ChooseScan, "Scan ausw&hlen..." );
	 hMAdd = CreatePopupMenu();
    AppendMenu( hMAdd, MF_STRING, cm_FreezeCurve, "&Fixieren" );
    AppendMenu( hMAdd, MF_STRING, cm_KillSecondCurve, "Ls&chen" );
    AppendMenu( hMAdd, MF_STRING, cm_SaveSecondCurve, "&Speichern" );
    AppendMenu( TheMenu, MF_POPUP, ( WORD ) hMAdd, "&Scan" );
    hMAdd = CreatePopupMenu();
    AppendMenu( hMAdd, MF_STRING, cm_ShowPsdE_Data, "&Energie-Spektrum anzeigen" );
    AppendMenu( hMAdd, MF_STRING, cm_SetupPsd, "Ein&stellungen..." );
    AppendMenu( hMAdd, MF_STRING, cm_CalibratePsd, "&Calibrierung..." );
    AppendMenu( TheMenu, MF_POPUP, ( WORD ) hMAdd, "&Psd" );
    AppendMenu( TheMenu, MF_STRING, cm_DataAquisition, "&Datenerhebung..." );
#else
    AppendMenu( TheMenu, MF_STRING, cm_SetupAreaScan, "Setup &Measurement..." );
    AppendMenu( TheMenu, MF_STRING, cm_ShowCurveParam, "Visualising &Options..."
				  );
    AppendMenu( TheMenu, MF_STRING, cm_InitializeAreaScan, "Start &AreaScan" );
    AppendMenu( TheMenu, MF_SEPARATOR, 0, NULL );
    AppendMenu( TheMenu, MF_STRING, cm_ShowPsdP_Data, "Show &Impulse-Spectrum" );
    AppendMenu( TheMenu, MF_STRING, cm_PSDRemoteSyncCtl,
                "Measure external synchronized.." );
    AppendMenu( TheMenu, MF_STRING, cm_ChooseScan, "C&hoose Scan..." );
    hMAdd = CreatePopupMenu();
    AppendMenu( hMAdd, MF_STRING, cm_FreezeCurve, "&Fixing" );
    AppendMenu( hMAdd, MF_STRING, cm_KillSecondCurve, "&Clear" );
    AppendMenu( hMAdd, MF_STRING, cm_SaveSecondCurve, "&Save" );
    AppendMenu( TheMenu, MF_POPUP, ( WORD ) hMAdd, "&Scan" );
    hMAdd = CreatePopupMenu();
    AppendMenu( hMAdd, MF_STRING, cm_ShowPsdE_Data, "Show &Energy-Spectrum" );
    AppendMenu( hMAdd, MF_STRING, cm_SetupPsd, "&Settings..." );
    AppendMenu( hMAdd, MF_STRING, cm_CalibratePsd, "&Calibrate..." );
    AppendMenu( TheMenu, MF_POPUP, ( WORD ) hMAdd, "&Psd" );
    AppendMenu( TheMenu, MF_STRING, cm_DataAquisition, "Inquire &Data..." );
#endif
    //! alt // Reportstruktur fuer Absorber-Position, Omega und ???
    //! initial. der Datenbasis
    ScanReport = lpDBase->GetScanReport();
    lpDBase->New();
    nActiveScan = 0;
	 MainCurve = lpDBase->GetCurve( nActiveScan );
    // Fuer TPlotData
    LowerBound = 0.1;
    UpperBound = 10000.0;
    bXY_Scaling = TRUE;
    // pointer to output formats
    mlSetAxis( nOmega );
    strcpy( szODF, mGetDF() );
    strcpy( szOWF, mGetSF() );
    mlSetAxis( nTheta );
    eThetaUnitType = mGetUnitType();
    strcpy( szTDF, mGetDF() );
    strcpy( szTWF, mGetSF() );
    //! sperren von Psd-spezifischen Menuepunkten wenn kein Psd angeschlossen ist
	 if ( !dlIsDeviceValid( PsdDevice ) )
    {
        EnableMenuItem( TheMenu, cm_ShowPsdE_Data, MF_GRAYED );
        EnableMenuItem( TheMenu, cm_SetupPsd, MF_GRAYED );
        EnableMenuItem( TheMenu, cm_CalibratePsd, MF_GRAYED );
        EnableMenuItem( TheMenu, cm_ShowPsdP_Data, MF_GRAYED );
    }
    //! Scanstart ist erlaubt (param. ungueltig)
    //! FIX Fehler 77
    bScanSetupOk = FALSE;
};


//! loeschen der Datenbasis ,des Menues und speichern von Werten in der
//! Ini-Datei
TAreaScan::~TAreaScan()
{
    char buf[ MaxString ];
    RECT rc, rcm;

    //! Hauptfensterverweis auf areascanfenster loeschen + datenbasis loeschen
    Main.hAreaScanWindow = NULL;
    lpDBase->New();
    //! loeschen des Fenstermenue + senden von Detektorsignalen an das
	 //! AreaScanfenster beenden
    DestroyMenu( TheMenu );
    Device->MeasureStop();
    Device->SetHost( NULL );
    if ( bPsdDevice )
        Device->SetDisplay( NULL );
    Device->MeasureStart();
    //! AreaScanfenster-eigenschaften sowie Datenpfad,Messzeit und SaveOnReady in
    //! Ini-File ablegen
    GetWindowRect( GetFrameHandle(), &rcm );
    GetWindowRect( hWndChild, &rc );
    sprintf( buf, "%d", rc.left - rcm.left - 4 );
    WritePrivateProfileString( "AreaScan", "xo", buf, GetCFile() );
    sprintf( buf, "%d", rc.top - rcm.top - 42 );
	 WritePrivateProfileString( "AreaScan", "yo", buf, GetCFile() );
    sprintf( buf, "%d", rc.right - rc.left );
    WritePrivateProfileString( "AreaScan", "dx", buf, GetCFile() );
    sprintf( buf, "%d", rc.bottom - rc.top );
    WritePrivateProfileString( "AreaScan", "dy", buf, GetCFile() );
    WritePrivateProfileString( "AreaScan", "DataPath", szDataPath, GetCFile() );
    sprintf( buf, "%.2f", fMaxTime );
    WritePrivateProfileString( "AreaScan", "ExposureTime", buf, GetCFile() );
    sprintf( buf, "%d", bSaveOnReady );
    WritePrivateProfileString( "AreaScan", "SaveOnReady", buf, GetCFile() );
};

#pragma argsused

//! Funktion behandelt Fenstermenuepunkte
LRESULT TAreaScan::CallLocalAction( WPARAM wParam, LPARAM lParam )
{
    switch ( GET_WM_COMMAND_ID( wParam, lParam ) )
    {
        //! 'Choose Scan'
        //! aufruf der Dialogbox zur Auswahl der scans
    case cm_ChooseScan:
        //! FIX Fehler 46
        if(bShowPsdContinuous)
			{
         MessageBox(GetFocus(),szMsgLine017,szMessage,
         MBINFO);
         break;
         }
        TheModeless = ( TChooseScan* ) new TChooseScan( this );
        if ( TheModeless )
            TheModeless->Initialize();
        return 0l;

        //! 'Show Energy-Spectrum'
        //! kont. Anzeige des Energiespektrums aktivieren
    case cm_ShowPsdE_Data:
        ShowSensorContinuous( PsdEnergyData );
		  return 0l;

        //! 'Show Impulse-Spectrum'
        //! kont. Anzeige des Impulsspektrums aktivieren
    case cm_ShowPsdP_Data:
        ShowSensorContinuous( PsdPositionData );
        return 0l;

        //! 'Settings...'
        //! aufruf der Psd-Einstellungsbox
    case cm_SetupPsd:
        TheModeless = ( TPsdParameters* ) new TPsdParameters();
        if ( TheModeless )
            TheModeless->Initialize();
        break;

    }
    return 0l;
};

//***************** Mausbedienung *********************************************

//! aufruf wenn rechte Maustaste gedrueckt
//! Fenstermenue an aktueller Mausposition ausgeben
//! eingabeparam. aktuelle Mauspos.low(8) x-pos
//! high(8) y-pos.
void TAreaScan::rButtonDown( LONG lParam )
{
    POINT pp;
    //! sperren von 'Start AreaScan' wenn bereits ein Scan laeuft der nicht
    //! unterbrochen wurde
    //! FIX Fehler 
    if ( ( bMeasurementActive && !bInterrupted ) || !bScanSetupOk )
        EnableMenuItem( TheMenu, cm_InitializeAreaScan, MF_GRAYED );
    else
        EnableMenuItem( TheMenu, cm_InitializeAreaScan, MF_ENABLED );
    //! sperren von 'Choose Scan' wenn irgendeine nichtmodale Dialogbox aktiv ist
    if ( TheModeless )
		  EnableMenuItem( TheMenu, cm_ChooseScan, MF_GRAYED );
    else
        EnableMenuItem( TheMenu, cm_ChooseScan, MF_ENABLED );
    //! sperren von 'Settings...' wenn kein Psd verfuegbar ist
    if ( !bPsdDevice )
        EnableMenuItem( TheMenu, cm_SetupPsd, MF_GRAYED );
    else
        EnableMenuItem( TheMenu, cm_SetupPsd, MF_ENABLED );
    //! sperren von 'Fixing' wenn Darstellungsart ungleich Kurve + sperren von
    //! 'Inquire Data' wenn Darstellungsart gleich Kurve
    if ( eOutputType <= MatrixBitmap )
    {
        EnableMenuItem( TheMenu, cm_FreezeCurve, MF_GRAYED );
        EnableMenuItem( TheMenu, cm_DataAquisition, MF_ENABLED );
    }
    else
    {
        EnableMenuItem( TheMenu, cm_DataAquisition, MF_GRAYED );
        EnableMenuItem( TheMenu, cm_FreezeCurve, MF_ENABLED );
    }
    //! darstellen des Menues an der Mausposition
    pp.x = LOWORD( lParam );
    pp.y = HIWORD( lParam );
    ClientToScreen( hWndChild, &pp );
	 TrackPopupMenu( TheMenu, 0, pp.x, pp.y, 0, hWndChild, NULL );
};


//! aufruf wenn linke Maustaste losgelassen wurde(d.h. Endpunkt erreicht)
//! wird in 2 Faellen aktiv
//! - messen von entfernung zwischen zwei Punkten ueber TPlotData
//! - bei Dataaquisition(nMouseAction==100) zusaetzlich Kommando senden
void TAreaScan::lButtonUp( WPARAM wParam, LPARAM lParam )
{
    TPlotData::lButtonUp( wParam, lParam );
    if ( nMouseAction == 100 )
    {
        nMouseAction = 0;
		  PostMessage( hWndChild, WM_COMMAND, cm_DataAquisition, 0l );
    }
};


//! aufruf wenn linke Maustaste gedrueckt wurde(d.h Startpunkt wurde gewaehlt)
//! wird in 2 Faellen aktiv
//! - messen von entfernung zwischen zwei Punkten (nMouseAction=0)
//! - bei Dataaquisition (nMouseAction=100)
void TAreaScan::lButtonDown( WPARAM wParam, LPARAM lParam )
{
    if ( bAquisitionActive )
        nMouseAction = 100;
    else
        nMouseAction = 0;
    TPlotData::lButtonDown( wParam, lParam );
};


//! behandelt die Kommandos 'Setup Measurement...' und 'Inquire Data'
//! des Kindfenster-menue ; aufruf aus m_main.cpp DoCommandsChild()
void TAreaScan::InitializeDlg( WPARAM task, LPARAM )
{
    TModalDlg * dlg;

    switch ( task )
    {
        //! aufruf der Dialogbox 'Einstellungen AreaScan'
    case cm_SetupAreaScan:
        //! FIX Fehler 74
        mlSetAxis(nOmega);
        if (strcmp(mGetAxisName(),"Omega")||
          ((!mlIsAxisValid(Theta)&&!dlIsDeviceValid(PsdDevice))))
          {
          MessageBox(GetFocus(),szMsgLine021,szMsgFailure,MBINFO);
          break;
          } 
        dlg = ( TSetupAreaScan* ) new TSetupAreaScan( this );
        //! zeichnet DialogBox (in dlg_tpl.cpp)
        dlg->ExecuteDialog( hWndChild );
        delete dlg;
        //! Scanstart ist erlaubt (param. gueltig)
        //! FIX Fehler 77
        bScanSetupOk = TRUE;
        break;

	 case cm_DataAquisition:
        //! Aufruf durch Menue "Data Aquisition"/"Daten Erhebung"
        //! Benutzer zieht Gerade ueber ein Bitmap und es werden alle
        //! Punkte (Anzahl der Punkte vom Nutzer einstellbar) der Gerade berechnet
        //! Es werden berechnet Theta,Omega,RLX,RLY,Intensitaet,Delta
        //! Delta gibt die gemittelte Abweichung des berechneten Koordinatenpaars
        //! von einem tatsaechlich vorhandenen Messkoordinatenpaar an
        if ( bAquisitionActive )
        {
            FILE * hFile;
            char buf[ MaxString ];
            int cnt, env, row, column;
            float Odelta, Tdelta, x, y, z, offset, value;
            double yDelta, xDelta, Omega, Theta, rlxDelta, rlyDelta;
            TCurve* Scan;
            bAquisitionActive = FALSE;

            SetRanges();

            //! Punkte ausserhalb des Koordinatensystems nicht zulassen
            if (PointX[0]>AltCoorSys.xMax || PointX[1]>AltCoorSys.xMax ||
                    PointY[0]>AltCoorSys.yMax || PointY[1]>AltCoorSys.yMax ||
                    PointX[0]<AltCoorSys.xMin || PointX[1]<AltCoorSys.xMin ||
                    PointY[0]<AltCoorSys.yMin || PointY[1]<AltCoorSys.yMin)
				{
#ifdef GermanVersion
                MessageBox(GetFocus(),
                           "gewhlte Koordinaten ausserhalb des Koordinatensystems!",szMsgFailure,MBINFO );
#else
MessageBox(GetFocus(),
                "selected coordinates outside of the coordinate system!",szMsgFailure,MBINFO );
#endif
                break;
            }
            //! Beruecksichtigen, ob Gerade horizontal oder vertikal und nicht frei Hand...
            if (bSetDYZero)
                PointY[1]=PointY[0];
            if (bSetDXZero)
					 PointX[1]=PointX[0];

            yDelta=(PointY[1]-PointY[0])/nLinePoints;
            xDelta=(PointX[1]-PointX[0])/nLinePoints;

            //! wenn Abstand der Messpunkte nicht gross genug...
            if ((fabs(yDelta)<1e-7)&&(fabs(xDelta)<1e-7))
            {
#ifdef GermanVersion
                MessageBox(GetFocus(),"Eingabe wird verworfen !",szMsgFailure,
                           MBINFO );
#else
                MessageBox(GetFocus(),"Input is rejected !",szMsgFailure,
                           MBINFO );
#endif
                break;
            }

            //*** Point0 and Point1 are valid
            //! TData Struktur speichert errechnete Werte...
            lpData=(TData*) new TData[nLinePoints];
            //! Berechnung der Punkte der Gerade je nach Darstellungstyp
            switch (eOutputType)
            {
				case MatrixBitmap:
                //! nLinePoints gibt an, wieviele Messpunkte auf der Gerade liegen sollen...
                lpData[0].dTheta=PointX[0];
                lpData[0].dOmega=PointY[0];
                lpData[0].fDelta=lpData[0].fIntensity=0.0;
                for (cnt=1;cnt<nLinePoints;cnt++)
                {
                    lpData[cnt].fDelta=lpData[cnt].fIntensity=0.0;
                    lpData[cnt].dOmega=lpData[cnt-1].dOmega+yDelta;
                    lpData[cnt].dTheta=lpData[cnt-1].dTheta+xDelta;
                }
                break;

            case ReciprokeLatticeBitmap:
					 lpData[0].dX=PointX[0];
                lpData[0].dY=PointY[0];
                lpData[nLinePoints-1].dX=PointX[1];
                lpData[nLinePoints-1].dY=PointY[1];
                lpData[0].fDelta=lpData[0].fIntensity=0.0;
                lpData[nLinePoints-1].fDelta=lpData[nLinePoints-1].fIntensity=0.0;
                //! Zeile und Spalte im Bitmap berechnen
                row=(PointY[0]-AltCoorSys.yMin)/AltCoorSys.ySF;
                column=(PointX[0]-AltCoorSys.xMin)/AltCoorSys.xSF;
                //! Omega und Theta aus dem "Daten"Feld holen - Theta ist ohne Offset gespeichert
                lpData[0].dOmega=BSource->daten[row][column].omega;
                lpData[0].dTheta=BSource->daten[row][column].theta;
                lpData[0].dX=PointX[0];
                lpData[0].dY=PointY[0];

                //! Zeile und Spalte im Bitmap berechnen
                row=(PointY[1]-AltCoorSys.yMin)/AltCoorSys.ySF;
                column=(PointX[1]-AltCoorSys.xMin)/AltCoorSys.xSF;
                //! Omega und Theta aus dem "Daten"Feld holen - Theta ist ohne Offset gespeichert
                lpData[nLinePoints-1].dOmega=BSource->daten[row][column].omega;
                lpData[nLinePoints-1].dTheta=BSource->daten[row][column].theta;
                lpData[nLinePoints-1].dX=PointX[1];
                lpData[nLinePoints-1].dY=PointY[1];

					 //! nLinePoints gibt an, wieviele Messpunkte auf der Gerade liegen sollen...
                yDelta=(lpData[nLinePoints-1].dOmega-lpData[0].dOmega)/nLinePoints;
                xDelta=(lpData[nLinePoints-1].dTheta-lpData[0].dTheta)/nLinePoints;
                rlxDelta=(lpData[nLinePoints-1].dX-lpData[0].dX)/nLinePoints;
                rlyDelta=(lpData[nLinePoints-1].dY-lpData[0].dY)/nLinePoints;


                for(cnt=0;cnt<nLinePoints-1;cnt++)
                {
                    lpData[cnt+1].fDelta=lpData[cnt+1].fIntensity=0.0;
                    lpData[cnt+1].dOmega=lpData[cnt].dOmega+yDelta;
                    lpData[cnt+1].dTheta=lpData[cnt].dTheta+xDelta;
                    lpData[cnt+1].dX=lpData[cnt].dX+rlxDelta;
                    lpData[cnt+1].dY=lpData[cnt].dY+rlyDelta;
					 }
                break;
            }
            //*** search the related intensities
            //! berechnen der fehlenden Einheiten
            switch (eOutputType)
            {
            case MatrixBitmap:
                for (cnt=0;cnt<nLinePoints;cnt++)
                {
                    Omega=lpData[cnt].dOmega;
                    row=ScanReport->GetValueByValue(Omega,Odelta,offset);
                    //! Theta-Offset beruecksichtigen
                    Theta=lpData[cnt].dTheta-(GetThetaOffset(row)-GetThetaOffset(0));
                    Scan=lpDBase->GetCurve(row);
                    //! Omega-=Odelta;
                    //** pick out the intensity
                    column=Scan->GetValueByValue(Theta,Tdelta,value);
                    //! Theta-=Tdelta;
                    //! Omega und Theta in RL Koordinaten umrechnen
                    Omega=DegToRad(Omega);
                    Theta=DegToRad(lpData[cnt].dTheta);
                    lpData[cnt].dX=ArToRLx(Omega,Theta)*(M_PI/(0.5*Main.WaveLength));
                    lpData[cnt].dY=ArToRLy(Omega,Theta)*(M_PI/(0.5*Main.WaveLength));
						  //! lpData[cnt].fIntensity=value;
                    value=0;
                    //! nEnvironment liegt immer zwischen 0-3
                    env=nEnvironment;
                    //! beruecksichtigen der gewuenschten Umgebungsmesspunkte,
                    //! damit eventuelle krasse Intensitaetsunterschiede wegfallen
                    //! berechne Intensitaet
                    if (xDelta>yDelta)
                        while (env+1)
                        {
                            Scan->SetPP(column+env);
                            Scan->PGet(x,y,z);
                            value += y;
                            Scan->SetPP(column-env);
									 Scan->PGet(x,y,z);
                            value += y;
                            env--;
                        }
                    else
                        while (env+1)
                        {
                            Scan = lpDBase->GetCurve(row+env);
                            Scan->SetPP(column);
                            Scan->PGet(x,y,z);
                            value+=y;
                            Scan=lpDBase->GetCurve(row-env);
                            Scan->SetPP(column);
                            Scan->PGet(x,y,z);
                            value+=y;
                            env--;
                        }
                    //! bilde arithmetisches Mittel der Intensitaeten
                    lpData[cnt].fIntensity=value/((nEnvironment+1)*2);
                    //! quadriere Deltas, damit sich pos./neg. Werte nicht gegenseitig aufheben
                    lpData[cnt].fDelta=sqrt(pow(Odelta,2)+pow(Tdelta,2));
                }
                break;

				case ReciprokeLatticeBitmap:
                for (cnt=0;cnt<nLinePoints;cnt++)
                {
                    Omega=lpData[cnt].dOmega;
                    Theta=lpData[cnt].dTheta;
                    row = ScanReport->GetValueByValue(Omega,Odelta,offset);
                    //** reverse connection between psd and theta-axis
                    //! Omega-=Odelta;
                    Scan=lpDBase->GetCurve(row);
                    //** pick out the intensity
                    column=Scan->GetValueByValue(Theta,Tdelta,value);
                    //! Theta-Offset beruecksichtigen
                    lpData[cnt].dTheta=Theta + GetThetaOffset(row)-GetThetaOffset(0);

						  //! Theta-=Tdelta;
                    //! lpData[cnt].fIntensity=value;
                    value=0;
                    //! nEnvironment liegt immer zwischen 0-3
                    env=nEnvironment;
                    //! beruecksichtigen der gewuenschten Umgebungsmesspunkte,
                    //! damit eventuelle krasse Intensitaetsunterschiede wegfallen
                    //! berechne Intensitaet
                    if (Tdelta>Odelta)
                        while (env+1)
                        {
                            Scan->SetPP(column + env);
                            Scan->PGet(x,y,z);
                            value+=y;
                            Scan->SetPP(column-env);
                            Scan->PGet(x,y,z);
                            value+=y;
                            env--;
                        }
                    else
                        while (env+1)
                        {
                            Scan = lpDBase->GetCurve(row+env);
                            Scan->SetPP(column);
									 Scan->PGet(x,y,z);
                            value+=y;
                            Scan=lpDBase->GetCurve(row-env);
                            Scan->SetPP(column);
                            Scan->PGet(x,y,z);
                            value+=y;
                            env--;
                        }
                    //! bilde arithmetisches Mittel der Intensitaeten
                    lpData[cnt].fIntensity=value/((nEnvironment+1)*2);
                    //! quadriere Deltas, damit sich pos./neg. Werte nicht gegenseitig aufheben
                    lpData[cnt].fDelta=sqrt(pow(Odelta,2)+pow(Tdelta,2));
                }
                break;
				}
            //! Daten speichern
            hFile=fopen(DataFile,"w");
            if (!hFile)
            {
#ifdef GermanVersion
                strcpy( buf,"Probleme beim Anlegen der Datei !");
                MessageBox(GetFocus(),buf,szMessage,MBINFO );
#else
                strcpy( buf,"Problems when creating the file !");
                MessageBox(GetFocus(),buf,szMessage,MBINFO );
#endif
                delete[] lpData;
                return;
            }
            //! ergaenzt um Header und Data Info
#ifdef GermanVersion
            sprintf(buf,"[Header]\nGerade zwischen 2 Punkten \n");
#else
sprintf(buf,"[Header]\nLine between 2 points \n");
#endif
            fwrite( buf,strlen(buf),1,hFile);
            //! FileType mit eingefuehrt - TScan.eSaveFormat=dtnFile (beim Einlesen)
            sprintf( buf,"FileType=3\n",FileName );
				fwrite( buf,strlen( buf ), 1,hFile );
            sprintf( buf,"Source = %s\n",FileName );
            fwrite(buf,strlen(buf),1,hFile );

            //! Abfrage RL oder normale Koordinaten speichern
            if (!bSetRLSave)
            {
                sprintf( buf,"Omega Intens. Theta RLY RLX Delta\n",FileName );
                fwrite( buf,strlen(buf),1,hFile );
#ifdef GermanVersion
                sprintf(buf,"Omega aufsteigend geordnet\n",FileName );
#else
                sprintf(buf,"Omega ascending arranged\n",FileName );
#endif
					 fwrite(buf,strlen(buf),1,hFile);
                sprintf(buf,"[Data]\n",FileName);
                fwrite(buf,strlen(buf),1,hFile);
                //! Unterscheidung eingebaut, damit Omega aufsteigend abgespeichert
                if (lpData[0].dOmega<lpData[nLinePoints-1].dOmega)
                {
                    for (cnt=0;cnt<nLinePoints;cnt++)
                    {
                        sprintf( buf,"%.8f\t %.8f\t %.8f\t %.8f\t %.8f\t %.8f\n",
                                 lpData[cnt].dOmega,
                                 lpData[cnt].fIntensity,
                                 lpData[cnt].dTheta,
                                 lpData[cnt].dY,
                                 lpData[cnt].dX,
                                 lpData[cnt].fDelta);
                        fwrite(buf,strlen(buf),1,hFile );
                    }
                }
                else
                {
                    for (cnt=nLinePoints-1;cnt>=0;cnt--)
                    {
                        sprintf( buf,"%.8f\t %.8f\t %.8f\t %.8f\t %.8f\t %.8f\n",
                                 lpData[cnt].dOmega,
											lpData[cnt].fIntensity,
                                 lpData[cnt].dTheta,
                                 lpData[cnt].dY,
                                 lpData[cnt].dX,
                                 lpData[cnt].fDelta);
                        fwrite(buf,strlen(buf),1,hFile);
                    }
                }
            }
            else
            {
                sprintf(buf,"RLY Intens. RLX Omega Theta Delta\n",FileName);
                fwrite(buf,strlen(buf),1,hFile);
#ifdef GermanVersion
					 sprintf(buf,"RLY aufsteigend geordnet\n",FileName );
#else
                sprintf(buf,"RLY ascending arranged\n",FileName );
#endif
                fwrite(buf,strlen(buf),1,hFile);
                sprintf(buf,"[Data]\n",FileName);
                fwrite(buf,strlen(buf),1,hFile);
                //! Unterscheidung eingebaut, damit RLY aufsteigend abgespeichert
                if (lpData[0].dY<lpData[nLinePoints-1].dY)
                {
                    for (cnt=0;cnt<nLinePoints;cnt++)
                    {
                        sprintf( buf,"%.8f\t %.8f\t %.8f\t %.8f\t %.8f\t %.8f\n",
                                 lpData[cnt].dY,
                                 lpData[cnt].fIntensity,
                                 lpData[cnt].dX,
                                 lpData[cnt].dOmega,
                                 lpData[cnt].dTheta,
                                 lpData[cnt].fDelta);
                        fwrite(buf,strlen(buf),1,hFile );
                    }
                }
                else
                {
						  for (cnt=nLinePoints-1;cnt>=0;cnt--)
                    {
                        sprintf(buf,"%.8f\t %.8f\t %.8f\t %.8f\t %.8f\t %.8f\n",
                                lpData[cnt].dY,
                                lpData[cnt].fIntensity,
                                lpData[cnt].dX,
                                lpData[cnt].dOmega,
                                lpData[cnt].dTheta,
                                lpData[cnt].fDelta);
                        fwrite(buf,strlen(buf),1,hFile );
                    }
                }
            }
            fclose(hFile);
				delete[] lpData;
#ifdef GermanVersion
            sprintf(buf,"Die Daten wurden in der Datei %s gespeichert !", DataFile );
            MessageBox( GetFocus(), buf, "Daten-Erhebung", MBINFO );
#else
sprintf(buf,"The data were stored in the file %s !", DataFile );
            MessageBox( GetFocus(), buf, "Data-inquiries", MBINFO );
#endif
            return ;
        }
        dlg = ( TAquisition* ) new TAquisition();
        dlg->ExecuteDialog( hWndChild );
        delete dlg;
        break;
    }
    UpdateWnd( 0 );
};

//! Funktion wird bei WM_CREATE aus WndProc aufgerufen
//! testet ob weniger als 5 Fenster geoeffnet sind liefert dann ein true als
//! Rueckkehrcode ansonsten ein false
//! wahrscheinlich ueberfluessig (wird geerbt)
BOOL TAreaScan::CanOpen( void )
{
	 if ( !TMDIWindow::CanOpen() ) return FALSE;
    return TRUE;
};


//! test ob Fenster geschlossen werden kann
//! -test ob Messung aktiv, wenn ja, dann zuerst Messung unterbrechen
//! -test ob geaenderte Daten, wenn ja, dann Speicher-Anfrage
//! Rueckkehrcode False wenn kein Fenster goeffnet war sonst immer True
//! wahrscheinlich ueberfluessig (wird geerbt)
BOOL TAreaScan::CanClose( void )
{
    if ( !TMDIWindow::CanClose() ) return FALSE;
    return TRUE;
};


//! loescht aktuelle datenbasis + baut AreaScanfenster neu auf
//! Rueckkehrcode immer True
BOOL TAreaScan::New( void )
{
    lpDBase->New();
    nActiveScan = 0;
    MainCurve = lpDBase->GetCurve( nActiveScan );
    return TPlotData::New();
};


//! Darstellen des AreaScan-Fenster
void TAreaScan::Create( HWND hwnd )
{
    RECT rc;

    hWndChild = hwnd;
    Main.hAreaScanWindow = hwnd;
    Main.AreaScanWindow = this;
    Delay( 2000 );
    //! einlesen der Fenstereigenschaften, des Datenpfades aus dem
	 //! [AreaScan]-Abschnitt des Ini-Files
    rc.left = GetPrivateProfileInt( "AreaScan", "xo", 500, GetCFile() );
    rc.top = GetPrivateProfileInt( "AreaScan", "yo", 400, GetCFile() );
    rc.right = rc.left + GetPrivateProfileInt( "AreaScan", "dx", 170, GetCFile()
                                             );
    rc.bottom = rc.top + GetPrivateProfileInt( "AreaScan", "dy", 50, GetCFile()
                                             );
    GetPrivateProfileString( "AreaScan", "DataPath", "c:\\", szDataPath,
                             MaxString, GetCFile() );
    if ( szDataPath[ strlen( szDataPath ) - 1 ] != '\\' )
        strcat( szDataPath, "\\" );
    //! setzen der Filter und der Extension
    strcpy( szFilter, "HRM Standard (*.psd)|*.psd||" );
    strcpy( szExtension, "psd" );
	 //! Titelzeile des Fensters bestimmen + aktualisieren des Hauptmenues +
    //! darstellen des Scanfensters
    SetTitle();
    UpdateMenu();
    SetWindowPos( hWndChild, NULL, rc.left, rc.top, rc.right - rc.left,
                  rc.bottom - rc.top, SWP_NOZORDER );
};


//! setzt Titel des AreaScanFensters
//! Rueckkehrcode immer True
BOOL TAreaScan::SetTitle()
{
    char aTitle[ MaxString ];

#ifdef GermanVersion
    strcpy( aTitle, "HRM:" );
#else
    strcpy( aTitle, "AreaScan:" );
#endif
    //! haengt "<untitled.psd>" bei neuer Datei , sonst FileName an
    //! und schreibt ihn ins Fenster
    if ( bIsNewFile )
        strcat( aTitle, "<untitled.psd>" );
	 else
        strcat( aTitle, FileName );
    SetWindowText( hWndChild, aTitle );
    return TRUE;
};


//! zeichnet in abhaengigkeit des eingestellten Darstellungstyps das AreaScan-
//! fenster neu
void TAreaScan::UpdateWnd( int act )
{
    switch ( eOutputType )
    {
    case ReciprokeLatticeBitmap:
		  BSource->UpdateBitmapSource();
        break;
    case MatrixBitmap:
        BSource->UpdateBitmapSource();
        break;
    }
    //! behandelt Darstellungstyp Curve
    TMDIWindow::UpdateWnd( act );
};


//! setzt die Achsen-min. und -max. abhaengig von der Darstellungsart
void TAreaScan::SetRanges( void )
{
    float xshift;

    switch ( eOutputType )
    {
        //! Kurve
    case Curve:
        CoorSys.yMin = LowerBound;
        CoorSys.yMax = UpperBound;
        if ( !bPsdDevice )
        {
				//! wenn kein Psd dann test ob Punkte in Kurve
            if ( 1 > MainCurve->GetPNumber() )
            {
                //! wenn nicht x-Achse( -xx/2 -> xx/2)
                CoorSys.xMin = - dThetaWindow / 2.0;
                CoorSys.xMax = dThetaWindow / 2.0;
                break;
            }
            //! sonst x-Achse (min: auf min.Winkelwert der Kurve -> max: min + xx)
            CoorSys.xMin = MainCurve->Min[ P_X ];
            CoorSys.xMax = CoorSys.xMin + dThetaWindow;
            break;
        }
        //! Psd angeschlossen
		  if ( 2 > MainCurve->GetPNumber() )
        {
            //! kurve hat keine Punkte
            if ( bSecondaryCoor )
            {
                //! Kanaldarstellung => x-Achse (0 -> (Kurvenbereich/winkel
                //! pro Kanal))
                CoorSys.xMin = 0.0;
                CoorSys.xMax = Device->GetAngleRange( Sekunden ) /
                               Device->GetAngleStep();
                break;
            }
            //! Winkeldarstellung x-Achse
            CoorSys.xMin = dOmegaMin * dMoveRelation;
            CoorSys.xMax = CoorSys.xMin + Device->GetAngleRange();
            break;
        }
        //! Kurve hat Punkte
        if ( bSecondaryCoor )
        {
            CoorSys.xMin = MainCurve->Min[ P_Z ];
            CoorSys.xMax = MainCurve->Max[ P_Z ];
            break;
        }
		  //! liefert 0 wenn kein Psd ansonsten den ThetaOffset und setzt
        //! entsprechend die x-Achse
        xshift = GetThetaOffset( 0 );
        CoorSys.xMin = MainCurve->Min[ P_X ] + xshift;
        CoorSys.xMax = MainCurve->Max[ P_X ] + xshift;
        break;

        //! RL-Bitmap
    case ReciprokeLatticeBitmap:
        CoorSys.zMax = UpperBound;
        CoorSys.zMin = LowerBound;
        // The AltCoorSys is now used and will be setted in
        // TransformDBaseToBitmap()
        break;

        //! RAW-Matrix
    case MatrixBitmap:
        CoorSys.zMax = UpperBound;
        CoorSys.zMin = LowerBound;
        CoorSys.yMin = dOmegaMin;
        CoorSys.yMax = dOmegaMax;
        //! setzen der x-Achse in abhaengigkeit von Kurvenpunktzahl
        if ( 7 > MainCurve->GetPNumber())
        {
            CoorSys.xMin = dOmegaMin * dMoveRelation;
            CoorSys.xMax = CoorSys.xMin + Device->GetAngleRange();
            break;
        }
        xshift = GetThetaOffset( 0 );
        CoorSys.xMin = MainCurve->Min[ P_X ] + xshift;
        //! dies muss mit rein! B.Buss
        xshift = GetThetaOffset(lpDBase->GetCNumber()-1);
        CoorSys.xMax = MainCurve->Max[ P_X ] + xshift;
        break;

    default:
		  MessageBox( GetFocus(), szMsgLine023, szMessage,
						  MBINFO );
		  break;
	 }
};

//! Funktion liefert den absoluten Thetawert als Rueckkehrcode
//! 1.Param. scid gibt Kurvennr. an, deren absoluter Thetawert gesucht ist
//! nur bei RL-Bitmap benutzt
double TAreaScan::GetThetaOffset( int scid )
{
    float theta, v;

    // this function returns an absolute Theta Value
    switch ( eOutputType )
    {
	 case Curve:
        //! bei kont.Anzeige den akt. Thetawinkel als Offset zurueck
        if ( bShowPsdContinuous )
            return ( mlGetValue( nTheta, Distance ) - mlGetOffset( nTheta ) );
        //! wenn kein Psd angeschl. offset=0
        if ( !bPsdDevice )
            theta = 0.0;
        else
        {
            //! Offset = thetawert der letzten Kurve holen wenn dieser gueltig ist
            //! sonst 0
            ScanReport->SetPP( nActiveScan );
            ScanReport->PGet( v, theta, v );
            if ( ( theta > 1000.0 ) || ( theta < -1000.0 ) )
                theta = 0.0;
        }
        return theta;


    case ReciprokeLatticeBitmap:
        //! liefert 0 wenn zuwenig Kurven in Datenbasis sonst den Thetawert der
        //! scid-ten Kurve der Datenbasis
        if ( 2 > lpDBase->GetCNumber() ) return 0.0;
        ScanReport->SetPP( scid );
		  ScanReport->PGet( v, theta, v );
        return theta - dThetaOffset;

    case MatrixBitmap:
        //! liefert 0 wenn zuwenig Kurven in Datenbasis sonst den Thetawert der
        //! 0-ten Kurve der Datenbasis
        if ( 2 > lpDBase->GetCNumber() ) return 0.0;
        //! Aenderung B.Buss ScanReport->SetPP( 0 );
        ScanReport->SetPP( scid );
        ScanReport->PGet( v, theta, v );
        return theta - dThetaOffset;

    default:
        MessageBox( GetFocus(), szMsgLine023, szMessage,
						  MBINFO );
        return 0.0;
    }
};

//! bildn. Darstellung ausschl. in TPlotData verwendet
BOOL TAreaScan::SetMeasurementArea( TKSystem &ks )
{
    float fdTheta, thetamin;

    /*
    ::fPsdRange wird fuer jede Messung mit Device->GetAngleRange()
    oder nach dem Einlesen in LoadMeasurementInfo() und LoadOldData() gesetzt.
    */

    switch ( eOutputType )
    {
    case ReciprokeLatticeBitmap:
        fdTheta = ( dOmegaMax - dOmegaMin ) * dMoveRelation;
        thetamin = GetThetaOffset( 0 ); // + dOmegaMin * dMoveRelation;
        thetamin += MainCurve->Min[ 0 ];
        ks[ 0 ].x = DegToRad ( thetamin );
        ks[ 0 ].y = DegToRad ( dOmegaMin );
        ks[ 0 ].Ord = 0;
		  ks[ 1 ].x = DegToRad ( thetamin + ::fPsdRange );
        ks[ 1 ].y = DegToRad ( dOmegaMin );
        ks[ 1 ].Ord = 1;
        ks[ 2 ].x = DegToRad ( thetamin + fdTheta + ::fPsdRange );
        ks[ 2 ].y = DegToRad ( dOmegaMax );
        ks[ 2 ].Ord = 2;
        ks[ 3 ].x = DegToRad ( thetamin + fdTheta );
        ks[ 3 ].y = DegToRad ( dOmegaMax );
        ks[ 3 ].Ord = 3;
        break;

    case MatrixBitmap:
        ks[ 0 ].x = 0.0;
        ks[ 0 ].y = dOmegaMin;
		  ks[ 0 ].Ord = 0.0;
        ks[ 1 ].x = ::fPsdRange;
        ks[ 1 ].y = dOmegaMin;
        ks[ 1 ].Ord = 1;
        //! B.Buss geaendert ks[ 2 ].x = ::fPsdRange;
        ks[ 2 ].x = GetThetaOffset(lpDBase->GetCNumber()-1)-GetThetaOffset(0) + ::fPsdRange;
        ks[ 2 ].y = dOmegaMax;
        ks[ 2 ].Ord = 2;
        ks[ 3 ].x = 0.0;
        ks[ 3 ].y = dOmegaMax;
        ks[ 3 ].Ord = 3;
        break;
    }
    return TRUE;
};

//! wird aufgerufen aus m_main.cpp bei cm_InitializeScan
//! startet den Scanvorgang
void TAreaScan::InitializeTask( WPARAM, LPARAM )
{
    char buf[ 101 ];
    char fmt[ MaxString ];
#ifdef GermanVersion
    char HeadLine[] = "Start AreaScan";
#else
    char HeadLine[] = "Starting AreaScan";
#endif
    char msg[ 101 ];

    //! Scan nicht bei kont. Anzeige erlaubt
    if ( bShowPsdContinuous )
    {
        LoadString( Main.hInstance, sth_StopContiniousPsd, msg, 100 );
        MessageBox( hWndChild, msg, HeadLine, MBSTOP );
        return ;
	 }
	 // Alte Daten sichern bzw. neuen Namen vergeben
	 //! test ob die Anzahl der Erwarteten Scans die max. Kapaz. der Datenbasis
	 //! ueberschreitet
	 if ( ( ( dOmegaMax - dOmegaMin ) / dOmegaWidth ) >
				lpDBase->GetMaxScanNumber() )
	 {
		  sprintf( msg, szMsgLine008, lpDBase->GetMaxScanNumber() );
		  MessageBox( hWndChild, msg, HeadLine, MBSTOP );
		  return ;
	 }
	 //! FIX Fehler 44
	 dThetaOffset = 0.0 ;
	 // Motoren initialisieren
	 mlSetAxis( nOmega );
	 mSetValue( Speed, 10000.0 );
	 //! wenn omega-relativ abfrage ob relative Null zuruecksetzen
	 switch ( eScanType )
	 {
	 case Omega2ThetaScan:
		  if ( !mIsDistanceRelative() ) break;
		  strcpy( msg, szMsgLine007 );
		  if ( IDYES == MessageBox( hWndChild, msg, HeadLine, MBASK ) )
				mSetRelativeZero( NO, 0.0 );
	 }
	 mlSetAxis( nTheta );
	 mSetValue( Speed, 10000.0 );
	 //! wenn theta-relativ abfrage ob relative Null zuruecksetzen
	 switch ( eScanType )
	 {
	 case Omega2ThetaScan:
		  if ( !mIsDistanceRelative() ) break;
		  strcpy( msg, szMsgLine006 );
		  if ( IDYES == MessageBox( hWndChild, msg, HeadLine, MBASK ) )
		  {
				mSetRelativeZero( NO, 0.0 );
				dThetaOffset = 0.0;
		  }
		  else
				dThetaOffset = mlGetOffset( nTheta );
	 }
	 //! auswahl des Scanstartdialogs
	 switch ( eScanType )
	 {
	 case Omega2ThetaScan:
		  if ( bPsdDevice )
				sprintf( fmt, szMsgLine003, szODF, szODF );
		  else
		  {
				sprintf( fmt, szMsgLine004, szODF, szODF );
				dThetaOffset = 0.0;
		  }
		  break;

	 case StandardScan:
		  if ( !bPsdDevice ) break;
		  sprintf( fmt, szMsgLine005, szODF, szODF );
		  break;
	 default:
		  return ;
	 }
	 //! dialog anzeigen
	 sprintf( msg, fmt, dOmegaMin, dOmegaMax );
	 if ( IDNO == MessageBox( GetFocus(), msg, HeadLine, MBASK ) )
		  return ;
	 //! FIX Fehler 70
	 lpDBase->New();
	 //! FIX Fehler 32
	 if ( bSaveOnReady || bSaveContinuous)
		SaveFile( SaveWithNewName );
	 // Sensoren initialisieren
	 Device->MeasureStop();
	 Steering.Reset();
	 Steering.StartUp( hWndChild, nOmega, Device->GetId() );
	 //! Werte an Detektor
	 Device->SetExposureValues( fMaxTime, dwMaxCounts, fFailure );
	 Device->SetParameters();
	 //! ueberfluessig (wahrscheinlich als erweiterung geplant)
	 switch ( eNotifyValue )
	 {
	 case MonitorIntensity:
		  if ( dlGetIdByName( MonitorDevice ) == Device->GetId() )
		  {
				sprintf( buf, szMsgLine002, Device->Characteristic );
				MessageBox( GetFocus(), buf, szMsgFailure, MBSTOP );
				return ;
		  }
		  Monitor->MeasureStop();
		  Monitor->SetHost( hWndChild );
		  Monitor->SetExposureValues( fMaxTime * 0.8, dwMaxCounts, fFailure );
		  break;

	 case AbsorberPosition:
		  break;
	 }
	 //! einstellen psd-spez. werte
	 switch ( eScanType )
	 {
	 case Omega2ThetaScan:
		  if ( bPsdDevice )
		  {
				//! art der Kurvenaktualisierung einstellen
				Device->SetSignalGrowUp( TRUE );
				//! einstellen der Anzahl der zusammenzufassenden Kanaele
				Device->SetAddedChannels( nAddedChannels );
				//! winkelbereich eines Spektrums ermitteln bei psd
				::fPsdRange = Device->GetAngleRange( eThetaUnitType );
		  }
		  else
				//! winkelbereich eines Spektrums ermitteln bei 0-dim. Det.
				::fPsdRange = dThetaWindow;
		  break;

	 case StandardScan:
		  if ( !bPsdDevice )
		  {
				SetInfo( szMsgLine025 );
				return ;
		  }
		  //! art der Kurvenaktualisierung einstellen
		  Device->SetSignalGrowUp( TRUE );
		  //! einstellen der Anzahl der zusammenzufassenden Kanaele
		  Device->SetAddedChannels( nAddedChannels );
		  //! winkelbereich eines Spektrums ermitteln bei Psd
		  ::fPsdRange = Device->GetAngleRange( eThetaUnitType );
		  break;
	 }
	 // ******* Alte Daten verwerfen *********************************************
	 bFirstScan = TRUE;
	 //! Darstellungsoptionen fuer Scan setzen
	 Steering.Visualising( 0, 0, 0, 0, 0, 0 );
	 // Scan starten
	 switch ( eScanType )
	 {
	 case Omega2ThetaScan:
		  if ( bPsdDevice )
		  {
				//! Anweisungen sind doppelt
				Device->SetSignalGrowUp( TRUE );
				Device->SetAddedChannels( nAddedChannels );
				strcpy( buf, "" );
				//! Scan starten
				Steering.StartCmdExecution( Scan, ForAreaScan, Omega2ThetaScan, buf,
													 GetWndHandle() );
		  }
		  else
		  {
				//! rel.Null fuer Motoren setzen
				bThetaScanCompleted = FALSE;
				mlSetAxis( nTheta );
				mSetRelativeZero( YES, mGetValue( Distance ) );
				mlSetAxis( nOmega );
				mSetRelativeZero( YES, mGetValue( Distance ) );
				strcpy( buf, "" );
				//! Scan starten
				Steering.StartCmdExecution( AreaScan, Omega2ThetaScan, 0, buf,
													 GetWndHandle() );
		  }
		  break;

	 case StandardScan:
		  //! Anweisungen sind doppelt
		  if ( !bPsdDevice )
		  {
				SetInfo( szMsgLine025 );
				return ;
		  }
		  Device->SetSignalGrowUp( TRUE );
		  Device->SetAddedChannels( nAddedChannels );
		  strcpy( buf, "" );
		  //! Scan starten
		  Steering.StartCmdExecution( Scan, ForAreaScan, StandardScan, buf,
												GetWndHandle() );
		  break;
	 }
	 //! akt.Kurve loeschen + AreaScan als aktiv kennzeichnen
	 MainCurve->New();
	 bMeasurementActive = TRUE;
	 UpdateMenu();
};

//********* Schnittstellen fuer Ablaufsteuerung *******************************
//! behandelt eigentlichen Scanablauf sowie die kont. Anzeige ,Calibrate ...
//! aufruf aus m_main.cpp wenn cm_CounterSet
void TAreaScan::CounterSetRequest( LPARAM lParam )
{
	 float absorber, channel, psdtheta, peakpos;
	 //! FIX Fehler 30
	 float x, y, x2, y2, z2, intens, integral, time;
	 //! FIX Fehler 47
	 char buf[ 3 * MaxString ], fmt[ 3 * MaxString ], msg[ MaxString ];
	 double dTheta, dOmega;
	 static float fMonitorSignal;
	 int nNumOffs = 0;

	 //! bei kont. Anzeige
	 if ( bShowPsdContinuous )
	 {
		  strcpy( msg, szMsgLine026 );
		  //! Kurvenspektrum+ integrale Intensitaet von Psd holen
		  Device->GetData( *MainCurve );
		  Device->GetData( integral );
		  //! wenn keine Calibr. dann Messung neu starten
		  //! (sonst wird dies in TCalibr. gemacht)
		  if ( !bCalibrationActive && Device->bDataValid )
				Device->MeasureStart();
		  sprintf( fmt, "%s Peak( %s | %s) Integral Intensity : %s", msg, szTDF,
					  "%.2f", "%.2f" );
        //! in abhaengigkeit von x-achsen-art(Kanal,Winkel) statuszeilen ausgabe
        if ( bSecondaryCoor )
        {
            //! Kanaldarst.
            channel = Device->GetMaximumChannel();
            intens = Device->GetMaximumIntensity();
            sprintf( buf, fmt, channel, intens, integral );
        }
        else
		  {
            //! Winkeldarst.
            MainCurve->GetGravityCenter( psdtheta, intens, channel, 2 );
            psdtheta += GetThetaOffset( 0 );
				sprintf( buf, fmt, psdtheta, intens, integral );
		  }
        SetInfo( buf );
		  UpdateWnd( 0 );
        return ;
    }
    //! bei unterbrochenem Scan + Scan nicht aktiviert abbruch
    if ( bInterrupted ) return ;
    if ( !bMeasurementActive ) return ;
    //! ab hier ablauf bei laufendem AreaScan
	 //! ueberfluessig (wahrscheinlich als Erweiterung geplant)
    switch ( eNotifyValue )
    {
    case MonitorIntensity:
        if ( lParam == dlGetIdByName( MonitorDevice ) )
		  {
            Monitor->GetData( fMonitorSignal );
            return ;
		  }
        break;
    }
    bFileChanged = TRUE;
    //! position der motoren holen + bei theta offset dazurechnen
    dOmega = mlGetValue( nOmega, Distance );
    dTheta = mlGetValue( nTheta, Distance );
    x = ( float ) dOmega;
    // Theta will be stored in absolute Koordinates
    y = ( float ) dTheta - dThetaOffset;
    //***************************************************************************
    //**** Datenbasis aktualisieren *********************************************
    //***************************************************************************
    //! erste Messung(erstes Spektrum wird nicht benutzt) weil Datenbasis schon
    //! mit einer Kurve init. wurde
    if ( bFirstScan )
		  nNumOffs = ( Device->bDataValid ) ? 0 : 0;
	 else
		  nNumOffs = ( Device->bDataValid ) ? 0 : 1;
    switch ( eScanType )
	 {
        //! Omega2Thetascan
    case Omega2ThetaScan:
        //###########################################################
        //! Scan mit Psd
        if ( bPsdDevice )
        {
            //! wenn Detektordaten gueltig
            //! wenn nicht 1.Spektrum in Datenbasis neues Spektrum hinzufuegen
            if ( Device->bDataValid )
				{
                if ( bFirstScan )
						  bFirstScan = FALSE;
                else
                {
						  lpDBase->AddCurve( MainCurve->GetPNumber() );
                    MainCurve = lpDBase->GetCurve( 10000 );
                    nActiveScan = lpDBase->GetCNumber() - 1;
					 }
				}
            //! Kurve + integrale Int. vom Detektor holen + Kurve in Datenbasis
            Device->GetData( *MainCurve );
            Device->GetData( integral );
            //! Bei Scan mit absorber seine position holen
            if ( bAbsorberUsed )
                absorber = mlGetValue( mlGetIdByName( Absorber ), Distance );
            else
                absorber = Device->GetMaximumChannel();
            //! Thetawinkel der Peakpos. holen
            MainCurve->GetGravityCenter( psdtheta, intens, peakpos, 2 );
            psdtheta += x;
            //! in abhaengigkeit von der eingestellten Reportart zum Spektrum die
				//! omega- , Thetapos. sowie den jeweiligen Reportwert im Scanreport
            //! speichern ueberfluessig (wahrscheinlich als Erweiterung geplant)
				if ( Device->bDataValid )
				{
                switch ( eNotifyValue )
                {
                case MonitorIntensity:
                    Monitor->MeasureStop();
                    ScanReport->PAdd( x, y, fMonitorSignal );
                    break;

                case AbsorberPosition:
                    ScanReport->PAdd( x, y, absorber );
                    break;

					 case MeasurementTime:
						  time = Device->dRealTime;
						  ScanReport->PAdd( x, y, time );
						  break;

					 default:
					 case IntegralIntensity:
						  ScanReport->PAdd( x, y, integral );
					 }
					 //! neues Spektrum in datei speichern bei kont. Speichern
					 if ( bSaveContinuous )
						  UpdateFile();
					 //! naechste pos. anfahren
					 Steering.DeviceRequest();
				}
		  }
		  //###########################################################
		  //! Scan mit 0-dim. Detektor
		  else
		  {
				//! im ersten schritt keine neue Kurve in Datenbasis
				if ( bFirstScan )
					 bFirstScan = FALSE;
				else
					 //! wenn 0-dim. detektor ueber gesamten Thetabereich gelaufen dann
					 //! eine neue Kurve in Datenbasis
					 if ( bThetaScanCompleted )
					 {
						  bThetaScanCompleted = FALSE;
						  //! bei kont. speichern akt. maincurve an datei anhaengen
						  //! FIX Fehler 34
						  if ( bSaveContinuous )
							  UpdateFile();
						  // save data about last scan
						  //! FIX Fehler 30,40
							MainCurve->SetPP(0);
							MainCurve->PGet(x2,y2,z2);
							MainCurve->GetGravityCenter(intens,intens,peakpos,2);
							ScanReport->PAdd(z2,x2,intens);
						  lpDBase->AddCurve( MainCurve->GetPNumber() );
						  MainCurve = lpDBase->GetCurve( 10000 );
						  nActiveScan = lpDBase->GetCNumber() - 1;
					 }
				//! intens.wert vom Detektor holen + an Kurve anhaengen
				Device->GetData( intens );
				//! FIX Fehler 30,40
				MainCurve->PAdd( y, intens, x );
				bFileChanged = TRUE;

				//! naechste pos. anfahren
				Steering.DeviceRequest();
		  }
		  break;

		  //#######################################################################
	 case StandardScan:
		  //! standardscan nur mit Psd erlaubt
		  if ( !bPsdDevice ) return ;
		  //! wenn Detektordaten gueltig
		  //! wenn nicht 1.Spektrum in Datenbasis neues Spektrum hinzufuegen
		  if ( Device->bDataValid )
		  {
				if ( bFirstScan )
					 bFirstScan = FALSE;
				else
				{
					 lpDBase->AddCurve( MainCurve->GetPNumber() );
					 MainCurve = lpDBase->GetCurve( 10000 );
					 nActiveScan = lpDBase->GetCNumber() - 1;
				}
		  }
		  //! Kurve + integrale Int. vom Detektor holen + Kurve in Datenbasis
		  Device->GetData( *MainCurve );
		  Device->GetData( integral );
		  //! Bei Scan mit absorber seine position holen
		  if ( bAbsorberUsed )
				absorber = mlGetValue( mlGetIdByName( Absorber ), Distance );
		  else
				absorber = Device->GetMaximumChannel();
		  //! Thetawinkel der Peakpos. holen
		  MainCurve->GetGravityCenter( psdtheta, intens, peakpos, 2 );
		  psdtheta += x;
		  //! in abhaengigkeit von der eingestellten Reportart zum Spektrum die
		  //! omega- , Thetapos. sowie den jeweiligen Reportwert im Scanreport
		  //! speichern ueberfluessig (wahrscheinlich als Erweiterung geplant)
		  if ( Device->bDataValid )
		  {
				switch ( eNotifyValue )
				{
				case MeasurementTime:
					 Device->GetData( integral );
					 ScanReport->PAdd( x, y, absorber );
					 break;

				case MonitorIntensity:
					 Monitor->MeasureStop();
					 ScanReport->PAdd( x, y, fMonitorSignal );
					 break;

				case AbsorberPosition:
					 ScanReport->PAdd( x, y, absorber );
					 break;

				case PeakPosition:
					 ScanReport->PAdd( x, y, peakpos );
					 break;

				default:
				case IntegralIntensity:
					 ScanReport->PAdd( x, y, integral );
				}
				bFileChanged = TRUE;
				//! neues Spektrum in datei speichern bei kont. Speichern
				if ( bSaveContinuous )
					 UpdateFile();
				//! naechste pos. anfahren
				Steering.DeviceRequest();
		  }
		  break;
	 }
	 //***************************************************************************
	 //**** Anzeige fuer Signalaufbau aktualisieren ******************************
	 //***************************************************************************
	 //! UpdateWindow:
	 switch ( eScanType )
	 {
	 case Omega2ThetaScan:
		  //! Anzeige bei 0-dim.Det.
		  if ( !bPsdDevice )
		  {
				//! string fuer Statusleiste erstellen
				sprintf( fmt, szMsgLine001, szODF, szTDF );
				sprintf( buf, fmt, dOmega, dTheta, intens );
				//! wenn akt. Kurve keine Punkte dann Fenster neuzeichnen sonst den
				//! neuen Punkt der Kurve einzeichnen
				if ( 1 == MainCurve->GetPNumber() )
					 UpdateWnd( 0 );
				else
					 UpdateWnd( O_PaintPoint );
		  }
		  //! Anzeige bei Psd
		  else
		  {
				//! string fuer Statusleiste erstellen
#ifdef GermanVersion
				sprintf( fmt, "Messung laeuft! O:%s T:%s", szODF, szTDF );
				sprintf( buf, "%s P(%s<>%%.1f) Gesamt-Intensitaet:%%.1f > %%d", fmt,
							szTDF );
#else
				sprintf( fmt, "Measurement ! O:%s T:%s", szODF, szTDF );
				sprintf( buf, "%s P(%s<>%%.1f) Integral Intensity:%%.lf > %%d", fmt,
							szTDF );
#endif
				strcpy( fmt, buf );
				nNumOffs += lpDBase->GetCNumber() - 1;
				if ( bSecondaryCoor )
					 sprintf( buf, fmt, dOmega, dTheta, peakpos, intens, integral,
								 nNumOffs );
				else
					 sprintf( buf, fmt, dOmega, dTheta, psdtheta, intens, integral,
								 nNumOffs );
				//! neue Kurve zeichnen
				UpdateWnd( 0 );
				//! wenn integr. Int. zu hoch dann Overflow ausgeben
				if ( Device->IsSoftOverflow() )
					 strcat( buf, " Overflow !" );
		  }
		  break;

	 case StandardScan:
		  //! nur fuer Psd erlaubt
		  if ( !bPsdDevice ) return ;
		  //! string fuer Statusleiste erstellen
		  sprintf( fmt, szMsgLine009, szODF );
		  sprintf( buf, szMsgLine010, fmt, szTDF );
		  strcpy( fmt, buf );
		  nNumOffs += lpDBase->GetCNumber() - 1;
		  if ( bSecondaryCoor )
				sprintf( buf, fmt, dOmega, peakpos, intens, integral, nNumOffs );
		  else
				sprintf( buf, fmt, dOmega, psdtheta, intens, integral, nNumOffs );
		  //! neue Kurve zeichnen
		  UpdateWnd( 0 );
		  //! wenn integr. Int. zu hoch dann Overflow ausgeben
		  if ( Device->IsSoftOverflow() )
				strcat( buf, " Overflow !" );
	 }
	 //! String in Statusleiste schreiben
	 SetInfo( buf );
};

//! wird augerufen nachdem AreaScan abgeschlossen wurde
//! aus m_main.cpp bei cm_SteeringReady
void TAreaScan::SteeringReady( LPARAM lParam )
{
	 char buf[ MaxString ];

	 // Funktion behandelt Meldung cm_CmdExecuted
	 bMeasurementActive = FALSE;
	 //! FIX Fehler 78
	 UpdateMenu();
	 Device->MeasureStop();
	 // Scan wurde ausgefuehrt
	 switch ( HIWORD( lParam ) )
	 {
	 case R_Failure:
		  sprintf( buf, szMsgLine020, LOWORD( lParam ) );
		  MessageBox( hWndChild, buf, szMsgFailure, MB_OK );
		  break;

		  //! keine Fehler aufgetreten
	 default:
		  //! Info in Statusleiste
		  sprintf( buf, szMsgLine011, lpDBase->GetCNumber() );
		  SetInfo( buf );
		  //! FIX Fehler 30,40
		  switch (eScanType){
		  case Omega2ThetaScan:if (!bPsdDevice)
										  {
										  //! die Werte zu der letzten Scankurve in Report-
										  //! kurve ablegen
										  //! FIX Fehler 30,40
											float x2,y2,z2,intens,peakpos;
											MainCurve->SetPP(0);
											MainCurve->PGet(x2,y2,z2);
											MainCurve->GetGravityCenter(intens,intens,peakpos,2);
											ScanReport->PAdd(z2,x2,intens);
											}
										break;

		  default: ;
		  }
		  //! wenn savecont. ausgewaehlt dann Headerinfo aktualisieren + Scanreport
		  if ( bSaveContinuous )
				// Header aktualisieren
		  {
				SaveMeasurementInfo( 1 );
				SaveReport();
		  }
				//! FIX Fehler 76
				if ( bSaveOnReady )
					 if ( SaveFile( NoAskForSave ) )
						  sprintf( buf, szMsgLine012 );
					 else
						  sprintf( buf, szMsgLine019 );
				//! FIX Fehler 76
				else if( bSaveContinuous )
						  sprintf( buf, szMsgLine012 );
					  else
						  sprintf( buf, szMsgLine018 );
				MessageBox( hWndChild, buf, szMessage, MBINFO );
		  }
	 //! Detektor stoppen
	 Device->MeasureStop();
	 Device->PopSettings();
	 Device->SetHost( NULL );
};

//! diese Fkt. schaltet die kont. Spektrumsanzeige fuer Psd an oder aus
//! 1.Param. type== PsdEnergyData(3000) => kont. EnergieSpektrum an/aus
//! PsdPositionData(3001) => kont. ImpulsSpekrum an/aus
//! (99) => schaltet kont. Spektrum aus
//! (0) => schaltet kont.Spektrum aus und dieses spaeter
//! wieder ein
//! nicht implementiert aber benutzt
void TAreaScan::ShowSensorContinuous( int type )
{
	 //! Variable merkt sich Art des eingest. kont. Spektrum
	 static int datatype;
#ifdef GermanVersion
	 char HeadLine[] = "Psd-Spektrum anzeigen";
#else
	 char HeadLine[] = "Show Psd-Spectrum";
#endif
	 TCurve* dummy = new TCurve(100);
	 char msg[ MaxString ];

	 //! kont. Anzeige nur bei Kurvendarst. erlaubt
	 if ( eOutputType != Curve )
	 {
		  strcpy( msg, szMsgLine027 );
		  MessageBox( hWndChild, msg, HeadLine, MBSTOP );
		  return ;
	 }
	 if ( type == 99 )
		  type = datatype;
	 //! kont. Anzeige nur fuer Psd erlaubt
	 if ( !dlIsDeviceValid( PsdDevice ) )
	 {
		  MessageBox( GetFocus(), szMsgLine024, szMessage, MBINFO );
		  return ;
	 }
	 bShowPsdContinuous = !bShowPsdContinuous;
	 lpDList->SetDevice( dlGetIdByName( PsdDevice ) );
	 SetDevice( dlGetDevice() );
	 Device->MeasureStop();
	 //! kont. Anzeige soll aktiviert werden
	 if ( bShowPsdContinuous )
	 {
		  //! FIX Fehler 46
		  MainCurve = dummy;
		  // Eingeschraenkte Aufloesung einstellen
		  Device->SetSignalGrowUp( FALSE );
		  Device->SetHost( hWndChild );
		  bSecondaryCoor = TRUE;
		  //! speichern der aktivierten Spektrumsart
		  datatype = type;
		  //! Anzeigeart an Psd uebergeben und im Menue kennzeichnen
		  switch ( type )
		  {
		  case PsdEnergyData:
				Device->SetDataType( PsdEnergyData );
				CheckMenuItem( TheMenu, cm_ShowPsdE_Data, MF_CHECKED );
				break;

		  case PsdPositionData:
				Device->SetDataType( PsdPositionData );
				CheckMenuItem( TheMenu, cm_ShowPsdP_Data, MF_CHECKED );
		  }
		  Device->MeasureStart();
	 }
	 //! kont. Anzeige soll ausgeschaltet werden
	 else
	 {
		  //*** switch off visialising
		  //! anwaehlen einer kont. Darstellungsart wenn eine andere bereits aktiv
		  //! ist verhindern
		  //! FIX Fehler 46
		  MainCurve = lpDBase->GetCurve(nActiveScan);
		  if ( datatype != type )
		  {
				bShowPsdContinuous = !bShowPsdContinuous;
				Device->MeasureStart();
				strcpy( msg, szMsgLine017 );
				MessageBox( hWndChild, msg, HeadLine, MBINFO );
				return ;
		  }
		  //! alte Werte in Psd zuruecksetzen und im Menue Kennzeichnung entfernen
		  Device->PopSettings();
		  Device->SetHost( NULL );
		  Device->MeasureStart();
		  bSecondaryCoor = FALSE;
		  UpdateWnd( 0 );
		  if ( type == PsdEnergyData )
		  {
				CheckMenuItem( TheMenu, cm_ShowPsdE_Data, MF_UNCHECKED );
				Device->SetDataType( PsdPositionData );
		  }
		  else
				CheckMenuItem( TheMenu, cm_ShowPsdP_Data, MF_UNCHECKED );
	 }
};

//! aufruf aus CallLocalAction zur PsdCalibrierung
//! FIX Fehler 35
void TAreaScan::CalibratePsd( void )
{
	 char buf[ MaxString ];
	 HWND holddp;
	 TModalDlg* dlg;
	 BOOL bsCoor;

	 //! nur wenn Thetamotor und Psd verfuegbar
	 if ( !mlIsAxisValid( Theta ) || !dlIsDeviceValid( PsdDevice ) )
	 {
		  strcpy( buf, szMsgLine021 );
		  MessageBox( hWndChild, ( LPSTR ) buf, szMsgFailure, MB_OK );
		  return ;
	 }
	 if ( bShowPsdContinuous )
	 {
		  ShowSensorContinuous( 0 );
		  return ;
	 }
	 bCalibrationActive = TRUE;
	 lpDList->SetDevice( dlGetIdByName( PsdDevice ) );
	 SetDevice( dlGetDevice() );
	 //! kont.Anzeige wieder aktivieren + Kanaldarstellung waehlen
	 bShowPsdContinuous = TRUE;
	 holddp = Device->GetDisplay();
	 Device->SetDisplay( hWndChild );
	 Device->SetSignalGrowUp( FALSE );
	 bsCoor = bSecondaryCoor;
	 bSecondaryCoor = TRUE;
	 //! Calibrierungsdialogbox
	 dlg = ( TCalibratePsd* ) new TCalibratePsd( *MainCurve );
	 dlg->ExecuteDialog( hWndChild );
	 delete dlg;
	 //! alt // lpDList->CalibrateDlg(*MainCurve);
	 //! kont.Anzeige aus +alte Achsenbeschriftung
	 bShowPsdContinuous = FALSE;
	 bSecondaryCoor = bsCoor;
	 bCalibrationActive = FALSE;
	 Device->SetDisplay( holddp );
	 Device->MeasureStart();
};

//! ??
//! Aufruf aus CallLocalAction bei ExternalSync
//! Dialogbox unvollstaendig + gesamte Funktionalitaet ExternalSync nur in
//! Ansaetzen implementiert
void TAreaScan::ExternSychronized( void )
{
	 char buf[ MaxString ];
	 HWND holddp;
	 TModalDlg* dlg;
	 BOOL bsCoor, bshowpsd;

	 //! nur wenn Thetamotor und Psd verfuegbar
	 if ( !mlIsAxisValid( Theta ) || !dlIsDeviceValid( PsdDevice ) )
	 {
		  strcpy( buf, szMsgLine021 );
		  MessageBox( hWndChild, ( LPSTR ) buf, szMsgFailure, MB_OK );
		  return ;
	 }
	 //! ??
	 lpDList->SetDevice( dlGetIdByName( PsdDevice ) );
	 SetDevice( dlGetDevice() );
	 holddp = Device->GetDisplay();
	 Device->SetDisplay( hWndChild );
	 Device->SetSignalGrowUp( TRUE );
	 bshowpsd = bShowPsdContinuous;
	 bsCoor = bSecondaryCoor;
	 bSecondaryCoor = TRUE;
	 //! aufruf der Dialogbox
	 dlg = ( TPsdRemoteSync* ) new TPsdRemoteSync( *MainCurve );
    dlg->ExecuteDialog( hWndChild );
    delete dlg;
    bSecondaryCoor = bsCoor;
    Device->SetDisplay( NULL );
    if ( bshowpsd )
        ShowSensorContinuous( 0 );
    else
    {
        Device->SetDisplay( holddp );
        Device->MeasureStart();
    }
};

//! Fkt. wird bei unterbrechen/fortsetzen eines AreaScans aufgerufen oder zum
//! ausschalten einer kont. Anzeige
void TAreaScan::Interrupt()
{
    //! kont. Anzeige ausschalten wenn aktiv
    if ( bShowPsdContinuous )
    {
        ShowSensorContinuous( 99 );
        return ;
    }
    //! nur wenn AreaScan laeuft oder unterbrochener AreaScan existiert
    if ( !bMeasurementActive )
        return ;
    //! Hauptmenueeintrag aendern
    TMDIWindow::Interrupt();
    if ( !bInterrupted )
    {
        // Messung weiterfueren
        Steering.ToggleInterrupt();
        bNewCurveNeeded = FALSE;
    }
    else
    {
        //! Messung unterbrechen + in Statusleiste anzeigen
        Steering.ToggleInterrupt();
        SetInfo( szMsgLine013 );
    }
};

//******************* Read/Write **********************************************

//! ?
//! Rueckkehrcode bei ShiftedStandard ist die Anzahl der Psd-kanaele die
//! benoetigt werden um den Thetabereich zu ueberdecken
//! sonst immer 0
int TAreaScan::GetAdditionalColumns( void )
{
    if ( eSaveFormat != ShiftedStandard )
        return 0;
    if ( dOmegaWidth == 0.0 )
        return 0;
    return GetShift( ( ( dOmegaMax - dOmegaMin ) / dOmegaWidth ) + 1 );
};

//! Funktion liefert zu Anzahl der Scans (1.Parameter) Anzahl der Psd-kanaele
//! die benoetigt werden um den Thetabereich zu ueberdecken
//! (nur bei ShiftedStan.) sonst 0 als Rueckkehrcode
int TAreaScan::GetShift( int ScanNumber )
{
    if ( Device->GetWidth() == 0.0 )
        return 0;
    if ( eScanType == StandardScan )
        return 0;
    return ScanNumber * ( dOmegaWidth * dMoveRelation ) / Device->GetWidth();
};


//! Funktion speichert Headerinformationen zu einem Areascan in einer Datei
//! 1.Parameter gibt an, ob die Datei neu erstellt(=0) werden soll oder nur
//! aktualisiert (ungl. 0) werden soll
//! Rueckkehrcode false wenn probleme beim erstellen bzw. oeffnen der Datei
//! sonst immer true
BOOL TAreaScan::SaveMeasurementInfo( BOOL UpdateHeader )
{
    int hFile;
    UINT nSize;
    char *data;
    TCurve* Report = lpDBase->GetScanReport();
    char buf[ MaxString + 1 ], buf2[ MaxString / 2 ], buf3[ MaxString / 2 ];
    char format[ 2 * MaxString + 1 ];
    int dataoffset = 1000, ival;
    OFSTRUCT of;
    struct date d;
    struct time t;

    //! oeffnet oder erstellt Datei + wenn Fehler dann Meldung + abbruch
    if ( UpdateHeader )
        hFile = OpenFile( FileName, &of, OF_WRITE );
    else
        hFile = OpenFile( FileName, &of, OF_CREATE );
    if ( -1 == hFile )
    {
        LoadString( Main.hInstance, sth_CannotOpenFile, buf, MaxString );
		  MessageBox( GetFocus(), buf, szMsgFailure, MB_OK | MB_ICONSTOP );
		  return FALSE;
	 }
	 //! Systemzeit + datum holen
	 getdate( &d );
	 gettime( &t );
	 //! Headerinformationen in String kopieren
	 data = new char[ 1001 ];
	 strcpy( format, "Comment=%s" );
    sprintf( buf, format, Main.Comment );
    strcpy( data, buf );
    strcat( data, EOL );

    strcat( data, "[Header]" );
    strcat( data, EOL );
    strcpy( format, "User=%s Date=%02i.%02i.%i Time=%2d:%02d:%02d" );
    sprintf( buf, format, Main.User, d.da_day, d.da_mon, d.da_year, t.ti_hour, \
             t.ti_min, t.ti_sec );
    strcat( data, buf );
    strcat( data, EOL );

    switch ( eSaveFormat )
    {
        //! Fehler tripel nicht moeglich
    case Tripel:
        strcpy( format, "Scan_Number=%d Point_Number_per_Scan=%d FileType=%d" );
        break;

    default:
        strcpy( format, "DataRows=%d DataColumns=%d FileType=%d" );
        // HD 960106
        strcat( format, EOL );
        strcat( format, "FirstColumn=0 LastColumns=%d" );
    }
    ival = lpDBase->GetCurve( 0 ) ->GetPNumber() + GetAdditionalColumns();
    sprintf( buf, format, lpDBase->GetCNumber(), ival, ( BOOL )
             ( eSaveFormat == StandardFile ), ival - 1 );
    strcat( data, buf );
    strcat( data, EOL );

    // aktuelle Bereiche abspeichern
    sprintf( format, "OmegaMin=%s OmegaStep=%s OmegaMax=%s", szODF, szOWF,
             szODF );
    sprintf( buf, format, Report->Min[ P_X ], dOmegaWidth, Report->Max[ P_X ] );
    strcat( data, buf );
    strcat( data, EOL );
    sprintf( format, "ThetaMin=%s ThetaStep=%s ThetaMax=%s MoveRelation=%%.2f",
             szTDF, szTWF, szTDF );
    sprintf( buf, format, Report->Min[ P_Y ],
             dOmegaWidth * dMoveRelation,
             Report->Max[ P_Y ],
             dMoveRelation );
    strcat( data, buf );
    strcat( data, EOL );

    strcpy( format, "Target=%s Reflection=%s Orientation=%s" );
    GetHKL( Main.Reflection, buf2 );
    GetHKL( Main.Orientation, buf3 );
    sprintf( buf, format, Main.Target, buf2, buf3 );
    strcat( data, buf );
    strcat( data, EOL );
    strcpy( format, "WaveLength=%.3f Current=%d HV=%d" );
    sprintf( buf, format, Main.WaveLength, Main.Current, Main.Voltage );
    strcat( data, buf );
    strcat( data, EOL );

    //! in abhaengigkeit vom Detektor (0-dim. oder psd ) Fehler
    if ( bPsdDevice )
    {
        strcpy( format, "TimePerScan=%.2f PsdStep=%.6f PsdAddedChannels=%d" );
        sprintf( buf, format, fMaxTime, Device->GetWidth(), nAddedChannels );
        strcat( data, buf );
    }
    else
    {
        strcpy( format, "TimePerScan=%.2f" );
        sprintf( buf, format, fMaxTime );
        strcat( data, buf );
    }
    nSize = strlen( data );
    //! auffuellen de Strings mit Leerzeichen + ablegen des Strings in der Datei
    //! + schliessen der Datei
    for ( ; nSize < dataoffset - 10; nSize++ )
        data[ nSize ] = ' ';
    data[ nSize ] = 0x0;
    strcat( data, EOL );
    strcat( data, "[Data]" );
    strcat( data, EOL );
    _lwrite( hFile, data, strlen( data ) );
    _lclose( hFile );
    delete[] data;
    return TRUE;
};


//! Funktion speichert einen Messdatensatz
//! 1.Parameter gibt an ob neuer Dateiname zu waehlen ist (SaveWithNewName)
//! oder ob automatisch unter altem Namen (NoAskForSave) gespeichert werden
//! soll
//! Rueckkehrcode False wenn Fehler bei anlegen der Datei oder bei speichern
//! der headerinfos sonst immer true
BOOL TAreaScan::SaveFile( int ask )
{
    HCURSOR hCursor;
    TCurve* TheCurve;
    float fOmega, fIntensity, fPsdTheta, fTheta;
    float d0, d2;
    char *buf, fmt[ MaxString ], msg[ MaxString ];
    int hFile, idx, numbercolumn, nCIdx;
    OFSTRUCT of;

    //! anlegen der Datei (event. mit eingabe des Dateinamen)
    if ( !TMDIWindow::SaveFile( ask ) )
		  return FALSE;
    //*** explicite repaint of window, since it's normally not possible.
    PAINTSTRUCT ps;
    HDC hdc = BeginPaint( hWndChild, &ps );
    Paint( hdc, &ps );
    EndPaint( hWndChild, &ps );
    //****************************
    //! ueberschreiben der Datei mit Headerinfo.
    if ( !SaveMeasurementInfo( 0 ) )
    {
        MessageBox( GetFocus(), szMsgLine014, szMsgFailure, MBINFO );
        return FALSE;
    }
    //! speichern der reportkurve
    SaveReport();
    hFile = OpenFile( FileName, &of, OF_WRITE );
    hCursor = SetCursor( LoadCursor( NULL, IDC_WAIT ) );
    // Daten an den Header anhaengen
    _llseek( hFile, 0, SEEK_END );
    // Hier zwischen den einzelnen Formaten waehlen
    switch ( eSaveFormat )
    {
        //! fehler (nur Standard moeglich)
    case ShiftedStandard:
        // 1. Scan ist noch nicht mit gueltigen Daten belegt
        if ( bSaveContinuous && ( 1 == lpDBase->GetCNumber() ) )
            break;
		  buf = new char [ 8 * 3000 ];
		  for ( nCIdx = 0; nCIdx < lpDBase->GetCNumber(); nCIdx++ )
		  {
				sprintf( buf, szMsgLine028, nCIdx + 1,
							lpDBase->GetCNumber() );
				SetInfo( buf );
				TheCurve = lpDBase->GetCurve( nCIdx );
				TheCurve->SetPP( 0 );
				TheCurve->FastOpen();
				numbercolumn = GetAdditionalColumns() + MainCurve->GetPNumber();
				for ( idx = 0; idx < numbercolumn; idx++ )
				{
					 if ( GetShift( nCIdx ) <= idx )
						  if ( TheCurve->FastPGet( d0, fIntensity, d2 ) )
								if ( 0.0 != fIntensity )
								{
									 short pp = 3 - log10( fIntensity );
									 strcpy( fmt, "%.3f " );
									 if ( pp < 0 ) pp = 0;
									 fmt[ 2 ] = ( char ) ( '0' + pp );
									 sprintf( buf, fmt, fIntensity );
									 goto Ready2;
								}
					 sprintf( buf, "0 " );
Ready2:
					 _lwrite( hFile, ( LPSTR ) buf, strlen( buf ) );
				}
				TheCurve->FastClose();
				strcpy( buf, EOL );
				_lwrite( hFile, ( LPSTR ) buf, strlen( buf ) );
		  }
		  delete[] buf;
		  break;

	 case StandardFile:
		  // 1. Scan ist noch nicht mit gueltigen Daten belegt
		  if ( bSaveContinuous && ( 1 == lpDBase->GetCNumber() ) )
				break;
		  buf = new char [ 8 * 3000 ];
		  numbercolumn = lpDBase->GetCurve( 0 ) ->GetPNumber();
		  //! alle Kurven der Datenbasis durchlaufen und jeweils alle Intens.werte
		  //! der Kurve in Datei ablegen
		  for ( nCIdx = 0; nCIdx < lpDBase->GetCNumber(); nCIdx++ )
		  {
				sprintf( buf, szMsgLine028, nCIdx + 1,
							lpDBase->GetCNumber() );
				SetInfo( buf );
				TheCurve = lpDBase->GetCurve( nCIdx );
				TheCurve->SetPP( 0 );
				TheCurve->FastOpen();
				for ( idx = 0; idx < numbercolumn; idx++ )
				{
					 if ( TheCurve->FastPGet( d0, fIntensity, d2 ) )
						  //! formatieren der Intensitaetswerte mit untersch. Genauigkeit
						  while ( 1 )
						  {
								if ( 0.00001 > fIntensity )
								{
									 sprintf( msg, "0 " );
									 break;
								}
								if ( 10.0 > fIntensity )
								{
									 sprintf( msg, "%.4f ", fIntensity );
									 break;
								}
								if ( 100.0 > fIntensity )
								{
									 sprintf( msg, "%.3f ", fIntensity );
									 break;
								}
								if ( 1000.0 > fIntensity )
								{
									 sprintf( msg, "%.2f ", fIntensity );
									 break;
								}
								sprintf( msg, "%.1f ", fIntensity );
								break;
						  }
					 else
						  strcpy( msg, "0 " );
					 if ( 0 == idx )
						  strcpy( buf, msg );
					 else
						  strcat( buf, msg );
				}
				//! ablegen einer Kurve als zeile in Datei
				strcat( buf, EOL );
				TheCurve->FastClose();
				_lwrite( hFile, ( LPSTR ) buf, strlen( buf ) );
		  }
		  delete[] buf;
		  break;

		  //! fehler (nur Standard moeglich)
	 case Tripel:
		  // 1. Scan ist noch nicht mit gueltigen Daten belegt
		  if ( bSaveContinuous && ( 1 == lpDBase->GetCNumber() ) )
				break;
		  nCIdx = 0;
		  buf = new char [ MaxString ];
		  ScanReport->SetPP( 0 );
		  ScanReport->FastOpen();
		  sprintf( fmt, "%s %s %s %s", szODF, szTDF, "%.3f", EOL );
		  while ( nCIdx < lpDBase->GetCNumber() )
		  {
				TheCurve = lpDBase->GetCurve( nCIdx );
				TheCurve->SetPP( 0 );
				TheCurve->FastOpen();
				ScanReport->FastPGet( fOmega, fTheta, d2 );
				while ( TheCurve->FastPGet( fPsdTheta, fIntensity, d0 ) )
				{
					 if ( bThetaAddsPsd )
						  fPsdTheta += fTheta;
					 sprintf( buf, fmt, fOmega, fPsdTheta, fIntensity );
					 _lwrite( hFile, buf, strlen( buf ) );
				}
				TheCurve->FastClose();
				nCIdx++;
		  }
		  ScanReport->FastClose();
		  delete[] buf;
		  break;

		  //! fehler (nur Standard moeglich)
	 case Bitmap:
		  ;
	 }
	 //! schliessen der Datei
	 _lclose( hFile );
	 SetCursor( hCursor );
	 bFileChanged = FALSE;
	 return TRUE;
};


//! haengt aktuelles Kurve an Datei mit FileName an
//! aufruf nur bei kontinuierlichem Speichern
//! Rueckkehrcode immer true
BOOL TAreaScan::UpdateFile( void )
{
	 HCURSOR hCursor;
	 TCurve* TheCurve;
	 float fOmega, fIntensity, fPsdTheta, fTheta;
	 float d0, d2;
	 char buf[ MaxString ], fmt[ MaxString ];
	 int hFile, idx, numbercolumn;
	 OFSTRUCT of;
	 //! nicht von Diffr.gruppe auskommentiert
	 //! int nOldId = mlGetAxis();

	 //! Datei oeffnen + Statusinfo ausgeben
	 hFile = OpenFile( FileName, &of, OF_WRITE );
	 hCursor = SetCursor( LoadCursor( NULL, IDC_WAIT ) );
	 _llseek( hFile, 0, SEEK_END );
	 lpDBase->GetCurve( 10000 ) ->SetPP( 0 ); // first point of last curve
	 sprintf( buf, szMsgLine029, lpDBase->GetCNumber() - 1 );
	 SetInfo( buf );
	 switch ( eSaveFormat )
	 {
	 case StandardFile:
		  //! letzte Kurve der Datenbasis auswaehlen + alle Intens.werte der Kurve
		  //! auslesen und als zeile an Datei anhaengen
		  numbercolumn = lpDBase->GetCurve( 0 ) ->GetPNumber();
		  TheCurve = lpDBase->GetCurve( 10000 );
		  TheCurve->FastOpen();
		  TheCurve->SetPP( 0 );
		  for ( idx = 0; idx < numbercolumn; idx++ )
		  {
				if ( TheCurve->FastPGet( d0, fIntensity, d2 ) )
					 //! bestimmt anzahl dez.-stellen und legt Intensitaetswert demenstpr.
					 //! formatiert ab
					 if ( 0.0 != fIntensity )
					 {
						  short pp = 3 - log10( fIntensity );
						  if ( pp < 0 ) pp = 0;
						  strcpy( fmt, "%.3f " );
						  fmt[ 2 ] = ( char ) ( '0' + pp );
						  sprintf( buf, fmt, fIntensity );
						  goto Ready;
					 }
				sprintf( buf, "0 " );
Ready:
				_lwrite( hFile, ( LPSTR ) buf, strlen( buf ) );
		  }
		  TheCurve->FastClose();
		  strcpy( buf, EOL );
		  _lwrite( hFile, ( LPSTR ) buf, strlen( buf ) );
		  break;

		  //! fehler (nur Standard moeglich)
	 case Tripel:
		  ScanReport->BackStep();
		  ScanReport->PGet( fOmega, fTheta, d2 );
		  TheCurve = lpDBase->GetCurve( 10000 );
		  TheCurve->SetPP( 0 );
		  TheCurve->FastOpen();
		  sprintf( fmt, "%s %s %s %s", szODF, szTDF, "%.3f", EOL );
		  while ( TheCurve->FastPGet( fPsdTheta, fIntensity, d0 ) )
		  {
				if ( bThetaAddsPsd )
					 fPsdTheta += fTheta;
				sprintf( buf, fmt, fOmega, fPsdTheta, fIntensity );
				_lwrite( hFile, ( LPSTR ) buf, strlen( buf ) );
		  }
		  TheCurve->FastClose();
	 }
	 //! Datei schliessen
	 _lclose( hFile );
	 SetCursor( hCursor );
	 bFileChanged = FALSE;
	 return TRUE;
};

//! speichert die zur Datenbasis gehoerige Scanreportkurve in einer Datei unter
//! dem aktuellen Dateinamen mit der Extension .rep ab
//! Rueckkehrcode immer true
BOOL TAreaScan::SaveReport( void )
{
	 HCURSOR hCursor;
	 float fOmega, fReport, fTheta;
	 char buf[ MaxString ];
	 char fmt[ MaxString ];
	 int hFile, cnt;
	 OFSTRUCT of;
	 char fn[ MAXPATH ];
	 char drive[ MAXDRIVE ], path[ MAXDIR ], name[ MAXFILE ], ext[ MAXEXT ];

	 //! ermitteln des Dateinamen + anhaengen der Extension .rep + erstellen der
	 //! Datei
	 fnsplit( FileName, drive, path, name, ext );
	 fnmerge( fn, drive, path, name, "rep" );
	 hFile = OpenFile( fn, &of, OF_CREATE );
	 hCursor = SetCursor( LoadCursor( NULL, IDC_WAIT ) );
	 //! abhaengig von eingestellter Zusatzinformation Tabellenkopf speichern
	 switch ( eNotifyValue )
	 {
	 case MonitorIntensity:
		  sprintf( buf, "# Report: ScanId Omega : Theta : Monitor Signal" );
		  break;
	 case MeasurementTime:
		  sprintf( buf, "# Report: ScanId Omega : Theta : MeasurementTime" );
		  break;
	 case AbsorberPosition:
		  sprintf( buf, "# Report: ScanId Omega : Theta : AbsorberPosition" );
		  break;
	 case PeakPosition:
		  sprintf( buf, "# Report: ScanId Omega : Theta : PeakPosition" );
		  break;
	 default:
	 case IntegralIntensity:
		  sprintf( buf, "# Report: ScanId Omega : Theta : Integral Intensity" );
		  break;
	 }
	 strcat( buf, EOL );
	 _lwrite( hFile, ( LPSTR ) buf, strlen( buf ) );
	 ScanReport->SetPP( 0 );
	 ScanReport->FastOpen();
	 cnt = 0;
	 sprintf( fmt, "%s %s %s %s %s", "%d", szODF, szTDF, "%.3f", EOL );
	 //! alle Werte der Scanreportkurve in Tabelle speichern +datei schliessen
	 while ( ScanReport->FastPGet( fOmega, fTheta, fReport ) )
	 {
		  sprintf( buf, fmt, cnt, fOmega, fTheta, fReport );
		  _lwrite( hFile, ( LPSTR ) buf, strlen( buf ) );
		  cnt++;
	 }
	 _lclose( hFile );
	 ScanReport->FastClose();
	 SetCursor( hCursor );
	 return TRUE;
};

//! Funktion laedt die zu einer .psd datei gehoerige Scanreportkurve
//! Rueckkehrcode False wenn Fehler bei oeffnen der Datei oder wenn weniger als
//! 3 Punkte in der Datei waren
//! true sonst
//! wird nicht benutzt
BOOL TAreaScan::LoadReport( void )
{
	 HCURSOR hCursor;
	 float fOmega, fPeakPos, fTheta;
	 char *data;
	 HFILE hFile;
	 char line[ MaxString ];
	 int cnt;
	 UINT wSize;
	 OFSTRUCT of;
	 char fn[ MAXPATH ];
	 char drive[ MAXDRIVE ], path[ MAXDIR ], name[ MAXFILE ], ext[ MAXEXT ];

	 fnsplit( FileName, drive, path, name, ext );
	 fnmerge( fn, drive, path, name, "rep" );
	 hFile = OpenFile( fn, &of, OF_READ );
	 if ( -1 == hFile )
		  return FALSE;
	 hCursor = SetCursor( LoadCursor( NULL, IDC_WAIT ) );
	 data = new char [ 25000 ];
	 wSize = ( int ) _llseek( hFile, 0, 2 );
	 _llseek( hFile, 0, 0 );
	 wSize = _lread( hFile, ( LPSTR ) data, wSize );
	 _lclose( hFile );
	 data[ wSize ] = '\0';
	 // erste Zeile verwerfen
	 GetBufferLine( data, line, MaxString );
	 ScanReport->FastOpen();
	 while ( GetBufferLine( NULL, line, MaxString ) )
	 {
		  if ( !strlen( line ) )
				continue;
		  sscanf( line, "%d %f %f %f", &cnt, &fOmega, &fTheta, &fPeakPos );
		  ScanReport->FastPAdd( fOmega, fTheta, fPeakPos );
	 }
	 delete[] data;
	 ScanReport->FastClose();
	 SetCursor( hCursor );
	 if ( 3 > ScanReport->GetPNumber() )
		  return FALSE;
	 return TRUE;
};


//! laden der Messungsinfos aus einer .psd datei
//! hFile ist Filehandle der Messdatei
//! Rueckkehrcode False wenn Datei zu kurz ,[HEADER] nicht vorhanden,
//! Filetyp ungl. 1 oder OmegaStep = 0
//! true sonst
BOOL TAreaScan::LoadMeasurementInfo( HFILE hFile )
{
	 char header[ 2048 ];
	 UINT wReadCnt;
	 int columns;
	 char *token, *info, *keyword;
	 BOOL retval = FALSE, bCheckHeader = FALSE;

	 nFirstReadColumn = nLastReadColumn = 0;
	 // Header-Marke suchen
	 //! test ob Datei zu kurz
	 _llseek( hFile, 0, 0 );
	 wReadCnt = _lread( hFile, ( LPSTR ) header, 2048 );
	 if ( wReadCnt < 50 )
		  goto Exit; // File korrupt
	 //! test ob [Header]-eintrag existiert
	 token = strtok( header, " \r\n" );
	 do
	 {
		  if ( strstr( token, "[Header]" ) )
				break;
		  token = strtok( NULL, " \r\n" );
		  if ( !token )
				goto Exit; // Kein Header enthalten
	 }


	 while ( 1 );
	 dThetaOffset = 0.0;
	 // Header-Informationen auswerten
	 while ( 1 )
	 {
		  keyword = strtok( NULL, " =\n\r" );
		  info = strtok( NULL, " =\n\r" );
		  if ( !strcmp( "Date", keyword ) ||
					 !strcmp( "DataRows", keyword ) ||
					 !strcmp( "Time", keyword ) ||
					 !strcmp( "HV", keyword )
			  )
				continue;
		  if ( !strcmp( "User", keyword ) )
		  {
				strcpy( Main.User, info );
				continue;
		  }
		  if ( !strcmp( "Target", keyword ) )
		  {
				strcpy( Main.Target, info );
				continue;
		  }
		  if ( !strcmp( "Substrat", keyword ) )
		  {
				strcpy( Main.TargetBulk, info );
				continue;
		  }
		  if ( !strcmp( "Reflection", keyword ) )
		  {
				SetHKL( Main.Reflection, info );
				continue;
		  }
		  if ( !strcmp( "Orientation", keyword ) )
		  {
				SetHKL( Main.Orientation, info );
				continue;
		  }
		  if ( !strcmp( "DataColumns", keyword ) )
		  {
				columns = atof( info );
				continue;
		  }
		  if ( !strcmp( "FirstColumn", keyword ) )
		  {
				nFirstReadColumn = atof( info );
				continue;
		  }
		  if ( !strcmp( "LastColumn", keyword ) )
		  {
				nLastReadColumn = atof( info );
				continue;
		  }
		  if ( !strcmp( "WaveLength", keyword ) )
		  {
				Main.WaveLength = atof( info );
				continue;
		  }
		  if ( !strcmp( "PsdStep", keyword ) )
		  {
				::fPsdRange = atof( info );
				continue;
		  }
		  if ( !strcmp( "ThetaMin", keyword ) )
		  {
				dThetaMin = atof( info );
				continue;
		  }
		  if ( !strcmp( "MoveRelation", keyword ) )
		  {
				dMoveRelation = atof( info );
				continue;
		  }
		  if ( !strcmp( "OmegaMin", keyword ) )
		  {
				dOmegaMin = atof( info );
				continue;
		  }
		  if ( !strcmp( "OmegaStep", keyword ) )
		  {
				dOmegaWidth = atof( info );
				continue;
		  }
		  if ( !strcmp( "TimePerScan", keyword ) )
		  {
				fMaxTime = atof( info );
				continue;
		  }
		  if ( !strcmp( "PsdAddedChannels", keyword ) )
		  {
				nAddedChannels = atoi( info );
				continue;
		  }
		  if ( !strcmp( keyword, "FileType" ) )
		  {
				if ( *info == '1' )
					 eSaveFormat = StandardFile;
				else
					 goto Exit; // Falsches File-Format
				continue;
		  }

		  if ( strstr( keyword, "[Data]" ) )
				break;
		  if ( strstr( info, "[Data]" ) )
				break;
	 }
	 //! alt // check infos
	 //! einige Headerwerte ueberpruefen und evtl. auf gueltige Werte setzen
	 if ( !nLastReadColumn )
		  nLastReadColumn = columns;
	 else
		  if ( nLastReadColumn > columns )
				nLastReadColumn = columns;
	 if ( !nFirstReadColumn )
		  nFirstReadColumn = 0;
	 if ( !dOmegaWidth )
		  bCheckHeader = TRUE;
	 dThetaOffset = dOmegaMin * dMoveRelation - dThetaMin;
	 if ( bCheckHeader )
	 {
		  MessageBox( GetFocus(), szMsgLine014, szMsgFailure, MBINFO );
		  goto Exit;
	 }
	 retval = TRUE;
Exit:
	 return retval;
};


//! liest gespeicherte Kurve (.psd)
//! ?? inputparam nicht implem.
//! Rueckkehrcode false wenn Fehler beim oeffnen der Datei, Extension ungl.
//! .psd, fehlerhaften Headerinfo. oder keine Eintraege nach[DATA]
//! sonst auch false (fehler)
BOOL TAreaScan::LoadOldData( int )
{
	 char buf[ MAXPATH ];
	 HFILE hFile;
	 TCurve* TheCurve;
	 HPSTR daten;
	 HCURSOR hCursor;
	 float omega, theta, intens, channel;
	 int cnt, column;
	 HGLOBAL hMem;
	 DWORD dwReadCnt;
	 OFSTRUCT of;
	 BOOL retval = FALSE;

	 //! ins Arbeitverzeichnis wechseln + Nachladebox oeffnen
	 chdir( szDataPath );
	 sprintf( buf, "*.%s", szExtension );
#ifdef GermanVersion
	 FileOpen( "File nachladen", szFilter, buf, szDataPath );
#else
	 FileOpen( "reload File", szFilter, buf, szDataPath );
#endif
	 if ( buf[ 0 ] == '*' )
		  return FALSE;
	 if ( strcmp( strupr( &( buf[ strlen( buf ) - 3 ] ) ), "PSD" ) )
		  return FALSE;
	 //*** clear data base
	 lpDBase->New();
	 strcpy( FileName, buf );
	 nActiveScan = 0;
	 MainCurve = lpDBase->GetCurve( nActiveScan );
	 UpdateWnd( 0 );
	 //*** explicite repaint of window, since it's normally not possible.
	 PAINTSTRUCT ps;
	 HDC hdc = BeginPaint( hWndChild, &ps );
	 Paint( hdc, &ps );
	 EndPaint( hWndChild, &ps );
	 //*** open file and allocate of memory for read buffer
	 hFile = OpenFile( FileName, &of, OF_READ );
	 dwReadCnt = _llseek( hFile, 0, 2 );
	 //*** load header information
	 if ( !LoadMeasurementInfo( hFile ) )
	 {
		  MessageBox( GetFocus(), szMsgLine014, szMsgFailure, MBINFO );
		  return FALSE;
	 }
	 //! test ob Werte hinter [DATA] folgen
	 if ( !SetFPOnData( hFile ) ) return FALSE;
	 //! Speicherblock der Laenge der Datei+100 anlegen + Datei in Speicherblock
	 //! kopieren letzte 3 Zeichen '/0' + Schliessen der Datei
	 hMem = GlobalAlloc( GMEM_MOVEABLE, dwReadCnt + 100 );
	 daten = ( HPSTR ) GlobalLock( hMem );
	 hCursor = SetCursor( LoadCursor( NULL, IDC_WAIT ) );
	 dwReadCnt = _hread( hFile, ( HPSTR ) daten, dwReadCnt );
	 daten[ dwReadCnt - 2 ] = '\0';
	 daten[ dwReadCnt - 1 ] = '\0';
	 daten[ dwReadCnt ] = '\0';
	 _lclose( hFile );
	 // read of old data
	 while ( 1 )
	 {
		  //! alle 5 gelesenen Scans Info ausgeben
		  if ( !( lpDBase->GetCNumber() % 5 ) )
		  {
#ifdef GermanVersion
				sprintf( buf, "%d Scan's gelesen", lpDBase->GetCNumber() );
#else
				sprintf( buf, "%d scan's read", lpDBase->GetCNumber() );
#endif
				SetInfo( buf );
		  }
		  TheCurve = lpDBase->GetCurve( 10000 );
		  TheCurve->FastOpen();
		  channel = theta = 0.0;
		  channel = 0.0;
		  column = 0;
		  cnt=0;
		  //! zeilenweises Einlesen der Messwerte
		  while ( 1 )
		  {
				cnt = 0;
				//! einlesen eines Messwertes
				while ( 1 )
				{
					 if ( *( daten + cnt ) == ' ' ) break;
					 if ( *( daten + cnt ) == '\t' ) break;
					 if ( *( daten + cnt ) == '\r' ) break;
					 if ( *( daten + cnt ) == '\n' ) break;
					 if ( *( daten + cnt ) == '\0' ) goto Exit;
					 cnt++;
				}
#ifdef __WIN32__
				//! Kopieren DEST , SRC , n Bytes
				memcpy( ( HPSTR ) buf, ( HPSTR ) daten, ( long ) cnt );
#else
				memcpy( ( HPSTR ) buf, ( HPSTR ) daten, cnt );
#endif
				daten += cnt;
				buf[ cnt ] = 0;
				intens = atof( buf );
				if ( column <= nLastReadColumn )
				{
					 if ( column >= nFirstReadColumn )
						  TheCurve->FastPAdd( theta, intens, channel );
					 column++;
					 channel += nAddedChannels;
					 theta += ::fPsdRange; // contains here the PsdStep
				}


				while ( *daten == ' ' ) daten++;
				while ( *daten == '\t' ) daten++;
				if ( *daten == '\r' ) break;
				if ( *daten == '\n' ) break;
				if ( *daten == '\0' ) goto Exit;
		  }
		  daten++;
		  if ( ( *daten == '\r' ) || ( *daten == '\n' ) )
				daten++;
		  TheCurve->FastClose();
		  lpDBase->AddCurve( nLastReadColumn - nFirstReadColumn + 10 );
	 }
Exit:
	 //! Bereich des PSD aus Min und Max der letzten Kurve ermitteln
	 ::fPsdRange = TheCurve->Max[ 0 ] - TheCurve->Min[ 0 ];
	 //*** Generation of ScanRep from ranges witch corrections of measurement area
	 {
		  omega = dOmegaMin;
		  theta = omega * dMoveRelation;
		  dThetaWidth = dOmegaWidth * dMoveRelation;
		  dOmegaMax = dOmegaMin + dOmegaWidth * ( lpDBase->GetCNumber() - 1 );

		  //! zur Neuberechnung eingefuegt NEU!
		  dThetaMin = dMoveRelation * dOmegaMin;
		  dThetaMax = dMoveRelation * dOmegaMax;

		  ScanReport->New();
		  ScanReport->FastOpen();
		  //! ScanReport erstellen

		  //! NEU!
		  float dummy;

		  for ( cnt = 0; cnt < lpDBase->GetCNumber(); cnt++ )
		  {
				//! NEU! Fehler 33
				TheCurve=lpDBase->GetCurve(cnt);
				TheCurve->GetGravityCenter(dummy,intens,dummy,2);
				ScanReport->FastPAdd( omega, theta, intens );
				omega += dOmegaWidth;
				theta += dThetaWidth;
		  }
		  ScanReport->FastClose();
	 }
	 //*** format data for output
	 SetCursor( hCursor );
	 bFileChanged = FALSE;
	 bIsNewFile = FALSE;
	 //! automatisch Bitmap errechnen wenn entspr. Ausgabetyp gewaehlt
	 if ( eOutputType <= MatrixBitmap )
		  BSource->FormatDBaseToBitmapSource();
	 //! Fenster erneuern + Info setzen + Speicher freigeben
	 UpdateWnd( 0 );
#ifdef GermanVersion
	 SetInfo( "archivierte Datendatei wurde gelesen" );
#else
	 SetInfo( "archived data-file was read" );
#endif
	 GlobalUnlock( hMem );
	 GlobalFree( hMem );
	 //! ? nicht eingeschaltet ?
#ifdef Peak_and_Cross
    //**** Daten aquirieren Peak- und Cross-Scan speichern **********************
    {
        float psdtheta, intens, channel, maxintens = 0.0;
        int maxcu, maxch;

        XShift = 0.0;
        for ( Idx = 0; Idx < lpDBase->GetCNumber(); Idx++ )
        {
            TheCurve = lpDBase->GetCurve( Idx );
            TheCurve->GetGravityCenter( psdtheta, intens, channel, 2 );
            if ( intens > maxintens )
            {
                maxintens = intens;
                maxcu = Idx;
                maxch = channel;
            }
        }
        TheCurve = lpDBase->GetCurve( maxcu );
        *SecondCurve = *TheCurve;
        SaveSecondCurve();
        SecondCurve->Delete();
        for ( Idx = 0; Idx < lpDBase->GetCNumber(); Idx++ )
        {
            TheCurve = lpDBase->GetCurve( Idx );
            TheCurve->SetPP( maxch );
            TheCurve->PGet( psdtheta, intens, channel );
            psdtheta = OmegaMin + Idx * OmegaWidth;
            SecondCurve->PAdd( psdtheta, intens, channel );
        }
        // Speichern der Curven
        SaveSecondCurve();
    }
#endif
    bOldDataLoaded = TRUE;
    return retval;
};
//*****************************************************************************
//******* Dialog zum Messen mit PSD unter externer Sychronisation *************
//*****************************************************************************

//! diese Dialogbox funktioniert nicht(unvollstaendig)
TPsdRemoteSync::TPsdRemoteSync( TCurve& curve ) : TModalDlg( "PSDRemoteSync" )
{
    Curve = &curve; // MainCurve vom Daten-Fenster
    hDlgItem = NULL;
    bCalibrationOk = FALSE;
    if ( !strlen( aTempPath ) )
        strcpy( aTempPath, "c:\\Work\\" );
    strcpy( aPath, aTempPath );
    if ( !strlen( aTempName ) )
        strcpy( aTempName, "GESI_474" );
    strcpy( aName, aTempName );
    nAskTime = 80;
    nCurveCount = 0;
    Device = lpDList->DP( dlGetIdByName( PsdDevice ) );
    if ( Device )
        Device->GetExposureValues( fExposureTime, dwExposureCounts, fError );
};

#pragma argsused
BOOL TPsdRemoteSync::Dlg_OnInit( HWND hwnd, HWND hwndCtl, LPARAM lParam )
{
    if ( !Device )
        return FALSE;
    Device->MeasureStop();
    Device->SetHost( GetHandle() );
    Device->SetSignalGrowUp( TRUE );
    // External Sync
    // Die Messzeit wird quasi auf unendlich gestellt
    // Ein Abbruch der Messung wird durch ein explizites aendern der Exposure-
    // Time erreicht.
    FORWARD_WM_COMMAND( hwnd, cm_ParamSet, hwndCtl, 0, SendMessage );
    hDlgItem = NULL;
    return TRUE;
};

void TPsdRemoteSync::Dlg_OnTimer( HWND hwnd, UINT id )
{
    switch ( id )
    {
    case TimerIdInformation:
        KillTimer( hwnd, TimerIdInformation );
        // Messung starten
        // Messung stoppen
    }


    return ;
};

void TPsdRemoteSync::PrintFileName( void )
{
    char aBuf[ 20 ];

    SetDlgItemText( GetHandle(), IDC_DirPSDCycle, aPath );
    SetDlgItemText( GetHandle(), IDC_TargetName, aName );
    sprintf( aBuf, ".%03d", nCurveCount );
    SetDlgItemText( GetHandle(), IDC_Extension, aBuf );
};

LPCSTR TPsdRemoteSync::GetFileName( void )
{
    sprintf( aFileName, "%s\\%s.%03d", aPath, aName, nCurveCount );
    return aFileName;
};

void TPsdRemoteSync::Dlg_OnCommand( HWND hwnd, int id, HWND hwndCtl,
                                    UINT codeNotify )
{
    switch ( id )
    {
    case cm_ParamSet:
        PrintFileName();
        if ( Device )
				SetDlgItemText( hwnd, IDC_Messages, "Initialisation OK" );
		  break;

	 case cm_CounterSet:
		  Device->UpdateDisplay();
        if ( Curve->Save( GetFileName(), 100, 2 ) )
        {
            PrintFileName();
            Device->SetExposureValues( fExposureTime, dwExposureCounts, fError );
				SetDlgItemText( hwnd, IDC_Messages, "Scan acquisition was ok" );
				break;
		  }
		  SetDlgItemText( hwnd, IDC_Messages, "Scan acquisition failed" );
		  break;

    case IDC_StopPSDCycle:
        KillTimer( hwnd, TimerIdInformation );
        break;

    case IDC_InterruptPSDCycle:
        KillTimer( hwnd, TimerIdInformation );
        break;

    case IDC_StartPSDCycle:
        GetDlgItemText( hwnd, IDC_DirPSDCycle, aPath, 10 );
        strcpy( aTempPath, aPath );
        GetDlgItemText( hwnd, IDC_TargetName, aName, 10 );
        strcpy( aTempName, aName );
        // check whether exist or not writable

        SetTimer( hwnd, TimerIdInformation, 100, NULL );
        break;


    default:
        TModalDlg::Dlg_OnCommand( hwnd, id, hwndCtl, codeNotify );
    }
};

BOOL TPsdRemoteSync::CanClose( void )
{
    return TRUE;
};

BOOL TPsdRemoteSync::LeaveDialog( void )
{
    KillTimer( GetHandle(), TimerIdInformation );
    Device->MeasureStop();
    Device->SetExposureValues( fExposureTime, dwExposureCounts, fError );
    Device->SetHost( NULL );
    return TRUE;
};

//*****************************************************************************
//******* Dialog zum Kalibrieren des Psd **************************************
//*****************************************************************************
#ifdef GermanVersion
TCalibratePsd::TCalibratePsd( TCurve &curve ) : TModalDlg( "CalibratePsd" )
#else
TCalibratePsd::TCalibratePsd( TCurve &curve ) : TModalDlg( "CalibratePsdEng" )
#endif
{
    Curve = &curve; // MainCurve vom Daten-Fenster
    hDlgItem = NULL;
    //! gibt an ob motor ueber groessere distanz faehrt
    bLongMove = FALSE;
    LeftPeak.Valid = FALSE;
    RightPeak.Valid = FALSE;
    //! gibt an ob rechter bzw. linker Peak schon erreicht ist
    bGetRightPeak = FALSE;
    bGetLeftPeak = FALSE;
    //! gibt an ob motor in bewegung
    bMoveActive = FALSE;
    //! wahrscheinlich ueberfluessig
    bCalibrationOk = FALSE;
    //! Zeitintervall zur akt. der Winkel in Dialogbox
    nAskTime = 80;
    //! Psd ermitteln + thetamotor setzen
    Device = lpDList->DP( dlGetIdByName( PsdDevice ) );
    nMotor = mlGetIdByName( Theta );
    mlSetAxis( nMotor );
    // Die Schrittweite des Psd dAngleStep wird stets in Winkelsekunden angegeben
    if ( Grad == mGetUnitType() )
        fRelationFactor = 1.0 / 3600.0;
    else
        if ( Minuten == mGetUnitType() )
            fRelationFactor = 1.0 / 60.0;
        else
            fRelationFactor = 1.0;
};

#pragma argsused

//! setzt Defaultwerte der Dialogbox bei Aufruf der Box
//! Rueckkehrcode immer true
BOOL TCalibratePsd::Dlg_OnInit( HWND hwnd, HWND hwndCtl, LPARAM lParam )
{
    //! alte Schrittweite merken + neue auf 1800 winkelsekunden setzen
    dOldMotorWidth = mGetValue( Width );
    mSetValue( Width, 1800.0 * fRelationFactor );
    //! Psd einstellen
    Device->MeasureStop();
    Device->SetAddedChannels( 2 );
    Device->SetHost( GetHandle() );
    Device->SetExposureValues( 2.0, 10000, 0.02 );
    Device->MeasureStart();
    Delay( 5000 );
    //! FIX Fehler 48
    dStepWidth = Device->GetAngleStep() ;
    hBar = GetDlgItem( GetHandle(), id_Bar );
    //! Timer starten + motor init. + DialogboxParameter setzen
    SetTimer( GetHandle(), TimerIdInformation, nAskTime, NULL );
    FORWARD_WM_COMMAND( hwnd, cm_MotorInit, hwndCtl, 0, SendMessage );
    FORWARD_WM_COMMAND( hwnd, cm_ParamSet, hwndCtl, 0, SendMessage );
    hDlgItem = NULL;
    return TRUE;
};

//! behandelt Timersignale zur aktualisierung der Winkelwerte in Dialogbox
void TCalibratePsd::Dlg_OnTimer( HWND hwnd, UINT id )
{
    char buf[ MaxString ];
    double dDistance;

    switch ( id )
    {
    case TimerIdInformation:
        //! Timer loeschen + Wait-mauszeiger setzen
        KillTimer( hwnd, TimerIdInformation );
        SetCursor( LoadCursor( NULL, IDC_WAIT ) );
        //! test ob motor an Ziel angekommen
        if ( mIsMoveFinish() )
        {
            //! Motorpos.bestimmung + test ob fehler
            if ( !mGetDistance( dDistance ) )
            {
                SetTimer( hwnd, TimerIdInformation, nAskTime, NULL );
                return ;
            }
            //! Winkel 2Thetawerte in Dialogbox schreiben + scrollbar aktualisieren
            sprintf( buf, mGetDF(), dDistance );
            SetDlgItemText( hwnd, id_NewAngle, buf );
            //! ueberfluessig
            sprintf( buf, mGetDF(), dDistance );
            SetDlgItemText( hwnd, id_Angle, buf );
            SetScrollPos( hBar, SB_CTL, GetBarPos(), TRUE );
            bMoveActive = FALSE;
            SetCursor( LoadCursor( NULL, IDC_ARROW ) );
        }
        //! motor in bewegung
        else
        {
            //! bei bewegung ueber groessere distanz den akt. Winkel in Dialogbox +
            //! scrollbar aktualisieren
            if ( bLongMove )
            {
                mGetDistance( dDistance );
                sprintf( buf, mGetDF(), dDistance );
                SetDlgItemText( hwnd, id_Angle, buf );
                SetScrollPos( hBar, SB_CTL, GetBarPos(), TRUE );
            }
            //! Timer neu setzen
            SetTimer( hwnd, TimerIdInformation, nAskTime, NULL );
        }
    }
    return ;
};

//! behandelt Kommandos in der Dialogbox
void TCalibratePsd::Dlg_OnCommand( HWND hwnd, int id, HWND hwndCtl,
                                   UINT codeNotify )
{
    char buf[ MaxString ];
    float val_f, channel, dd;
    static int MsgCnt = FALSE;

    switch ( id )
    {
        //! init. einiger Dialogboxelemente
    case cm_ParamSet:
        //! winkeleinheit+ akt. Winkel je Kanal setzen
        SetDlgItemText( GetHandle(), id_Unit, mGetAxisUnit() );
        //! FIX Fehler 48
        sprintf( buf, "%.3f", dStepWidth );
        SetDlgItemText( GetHandle(), id_StepWidth, buf );
        // Initialisieren des Motor-Scroll-Bar's
        SetScrollRange( hBar, SB_CTL, GetBarEgde( LEFT ), GetBarEgde( RIGHT ),
                        TRUE );
        SetFocus( hBar );
        break;

        //! Motor init.
    case cm_MotorInit:
        mActivateDrive();
        // Initialisieren des Positions-Eingabefenster's
        bMoveActive = TRUE;
        SetTimer( GetHandle(), TimerIdInformation, nAskTime, NULL );
        break;

        //! wenn Psdmessung fertig
    case cm_CounterSet:
        Device->UpdateDisplay();
        //! test ob rechte Peakpos. schon eingestellt wurde
        if ( bGetRightPeak )
        {
            //! ermitteln + speichern des Kanals der max. Intensitaet
            Curve->GetGravityCenter( dd, dd, channel, 2 );
            RightPeak.Pt[ 0 ] = channel;
            RightPeak.Valid = TRUE;
            bGetRightPeak = FALSE;
            //! wenn linke Peakpos. schon ermittelt
            if ( LeftPeak.Valid )
            {
                //! winkeldifferenz zwischen linken und rechten peak ermitteln
                val_f = ( LeftPeak.Pt[ 1 ] - RightPeak.Pt[ 1 ] );
                //! wenn linker peak == rechter peak dann rechte Peakpos. verwerfen
                if ( val_f == 0.0 )
                {
                    RightPeak.Valid = FALSE;
                    bGetRightPeak = TRUE;
                }
                else
                {
                    //! wenn gleicher kanal fuer linken und rechten peak dann
                    //! Fehlermeldung
                    if ( 0 != ( RightPeak.Pt[ 0 ] - LeftPeak.Pt[ 0 ] ) )
                    {
                        //! Winkel je kanal ausrechnen und an Psd uebergeben
                        val_f = val_f / ( RightPeak.Pt[ 0 ] - LeftPeak.Pt[ 0 ] ) /
                                fRelationFactor;
                        //! FIX Fehler 48
                        dStepWidth = val_f ;
                    }
                    else
                    {
								MessageBox( GetFocus(), szMsgLine022,
												szMsgFailure, MBINFO );
								//! FIX Fehler 58
								//! reset aller wichtigen Werte
								bLongMove = FALSE;
								LeftPeak.Valid = FALSE;
								RightPeak.Valid = FALSE;
								bGetRightPeak = FALSE;
								bGetLeftPeak = FALSE;
								bMoveActive = FALSE;
								EnableWindow( GetDlgItem( GetHandle(), cm_LeftPositionReached ),
								  TRUE);
								EnableWindow( GetDlgItem( GetHandle(), cm_RightPositionReached ),
                          TRUE);
                        break;
                    }
                }
            }
            //! sperren bzw. freigeben des rechte-Position-erreicht-Button
            EnableWindow( GetDlgItem( GetHandle(), cm_RightPositionReached ),
                          bGetRightPeak );
        }
        //! test ob linke Peakpos. schon eingestellt wurde
        if ( bGetLeftPeak )
        {
            //! ermitteln + speichern des Kanals der max. Intensitaet
            Curve->GetGravityCenter( dd, dd, channel, 2 );
            LeftPeak.Pt[ 0 ] = channel;
            LeftPeak.Valid = TRUE;
            bGetLeftPeak = FALSE;
            //! wenn rechte Peakpos. schon ermittelt
            if ( RightPeak.Valid )
            {
                //! winkeldifferenz zwischen linken und rechten peak ermitteln
                val_f = ( LeftPeak.Pt[ 1 ] - RightPeak.Pt[ 1 ] );
                //! wenn linker peak == rechter peak dann rechte Peakpos. verwerfen
                if ( val_f == 0.0 )
                {
                    LeftPeak.Valid = FALSE;
                    bGetLeftPeak = TRUE;
                }
                else
                {
                    //! wenn gleicher kanal fuer linken und rechten peak dann
                    //! Fehlermeldung
                    if ( 0 != ( RightPeak.Pt[ 0 ] - LeftPeak.Pt[ 0 ] ) )
                    {
                        //! Winkel je kanal ausrechnen und an Psd uebergeben
                        val_f = val_f / ( RightPeak.Pt[ 0 ] - LeftPeak.Pt[ 0 ] ) /
                                fRelationFactor;
                        //! FIX Fehler 48
                        dStepWidth = val_f ;
                    }
                    else
                     {
                        MessageBox( GetFocus(), szMsgLine022,
                                    szMsgFailure, MBINFO );
                        //! FIX Fehler 58
                        //! reset aller wichtigen Werte
                        bLongMove = FALSE;
                        LeftPeak.Valid = FALSE;
                        RightPeak.Valid = FALSE;
                        bGetRightPeak = FALSE;
                        bGetLeftPeak = FALSE;
                        bMoveActive = FALSE;
                        EnableWindow( GetDlgItem( GetHandle(), cm_LeftPositionReached ),
                          TRUE );
                        EnableWindow( GetDlgItem( GetHandle(), cm_RightPositionReached ),
                          TRUE );
                        break;
                    }
                }
            }
            //! sperren bzw. freigeben des linke-Position-erreicht-Button
            EnableWindow( GetDlgItem( GetHandle(), cm_LeftPositionReached ),
                          bGetLeftPeak );
        }
        //! Winkel je Kanal-Wert in Dialogbox
       //! FIX Fehler 48
        sprintf( buf, "%.3f", dStepWidth );
        SetDlgItemText( GetHandle(), id_StepWidth, buf );
        Device->SetAddedChannels( 2 );
        Device->MeasureStart();
        break;

        //! rechte Position erreicht-Button gedrueckt
    case cm_RightPositionReached:
        //! wenn Motor in bewegung abbrechen
        if ( bMoveActive )
            break;
        Device->MeasureStop();
        bGetRightPeak = TRUE;
        bGetLeftPeak = FALSE;
        //! 2Theta winkel speichern
        RightPeak.Pt[ 1 ] = mGetValue( Distance );
        Device->SetAddedChannels( 1 );
        Device->MeasureStart();
        SetFocus( hBar );
        break;

        //! linke Position erreicht-Button gedrueckt
    case cm_LeftPositionReached:
        //! wenn Motor in bewegung abbrechen
        if ( bMoveActive )
            break;
        Device->MeasureStop();
        bGetRightPeak = FALSE;
        bGetLeftPeak = TRUE;
        //! 2Theta winkel speichern
        LeftPeak.Pt[ 1 ] = mGetValue( Distance );
        Device->SetAddedChannels( 1 );
        Device->MeasureStart();
        SetFocus( hBar );
        break;

        //! eingabefeld fuer neuen Thetawinkel angewaehlt
        //! wird nachdem Beenden-Button gedrueckt noch 2-mal aufgerufen
    case id_NewAngle:
        hDlgItem = GetDlgItem( GetHandle(), id_NewAngle );
        MsgCnt--;
        if ( MsgCnt == 1 )
        {
            //! sorgt dafuer dass beim anclicken des Beenden-Buttons die Box
            //! verlassen wird
            hDlgItem = NULL;
            MsgCnt = 0;
        }
        break;

        //! behandelt Beenden-Button und Enter
    case IDOK:
        if ( !hDlgItem )
        {
            //! Box verlassen
            TModalDlg::Dlg_OnCommand( hwnd, id, hwndCtl, codeNotify );
            break;
        }
        // Der Nutzer hat mit Return eine neue Position eingegeben
        if ( hDlgItem == GetDlgItem( GetHandle(), id_NewAngle ) )
        {
            mStopDrive( TRUE );
            //! achtung sendet ein id_NewAngle
            GetDlgItemText( GetHandle(), id_NewAngle, buf, 10 );
            bLongMove = TRUE;
            mMoveToDistance( atof( buf ) );
            //! achtung sendet indirekt ein id_NewAngle
            FORWARD_WM_COMMAND( hwnd, cm_MoveButton, hwndCtl, 0, SendMessage );
            MsgCnt = 3;
        }
        hDlgItem = NULL;
        SetFocus( hBar );
        break;

        //! wird aufgerufen wenn motor durch direkte eingabe oder durch anclicken
        //! des scrollbars bewegt wird
    case cm_MoveButton:
        if ( bMoveActive )
            break;
        bMoveActive = TRUE;
        SetTimer( GetHandle(), TimerIdInformation, nAskTime, NULL );
        break;

        //! behandelt Abbruch
    default:
        TModalDlg::Dlg_OnCommand( hwnd, id, hwndCtl, codeNotify );
    }
};

#pragma argsused
//! behandelt alle Scrollbarereignisse
void TCalibratePsd::Dlg_OnHScrollBar( HWND hwnd, HWND hwndCtl, UINT code,
                                      int pos )
{
    switch ( code )
    {
        //! scrollbar um eine einheit nach links
    case SB_LINEUP:
        if ( bMoveActive )
            break;
        mMoveToDistance( mGetValue( Distance ) - mGetValue( Width ) );
        FORWARD_WM_COMMAND( hwnd, cm_MoveButton, hwndCtl, 0, SendMessage );
        break;

        //! scrollbar um eine einheit nach rechts
    case SB_LINEDOWN:
        if ( bMoveActive )
            break;
        mMoveToDistance( mGetValue( Distance ) + mGetValue( Width ) );
        FORWARD_WM_COMMAND( hwnd, cm_MoveButton, hwndCtl, 0, SendMessage );
        break;

        //! scrollbarereignisse ohne Wirkung
    case SB_ENDSCROLL:
    case SB_PAGEUP:
    case SB_PAGEDOWN:
        break;
    }
};

//! ermittelt Anzahl der Scrollbarschritte links bzw. rechts von der abs. Null
//! 1.Parameter side==LEFT Anzahl der Scrollbarschritte links von der abs. Null
//! sonst Anzahl der Scrollbarschritte rechts von der abs. Null
//! Rueckkehrcode Anzahl der Scrollbarschr. links bzw. rechts von der abs. Null
//! Achtung diese Funktion muss mit LEFT zuerst aufgerufen werden
int TCalibratePsd::GetBarEgde( int side )
{
    int steps, ret;
    // Geht vom symmetrischen Fall aus
    if ( side == LEFT )
    {
        steps = ( int ) ( mGetValue( MinDistance ) / mGetValue( Width ) );
        BarFactor = ( abs( steps ) < 20000 ) ? 1 : 2;
        ret = steps / BarFactor;
    }
    else
    {
        ret = ( mGetValue( MaxDistance ) / ( mGetValue( Width ) * BarFactor ) );
    }
    return ret;
};

//! liefert die Position des Scrollbar anhand der akt. Motorposition im
//!Rueckkehrcode
int TCalibratePsd::GetBarPos()
{
    int ret;

    ret = ( ( mGetValue( Distance ) ) / ( mGetValue( Width ) * BarFactor ) );
    return ret;
};

//! wird aufgerufen beim druecken des Beenden-Buttons
//! Rueckkehrcode False wenn der Winkel pro Kanal ==0
//! sonst true
BOOL TCalibratePsd::CanClose( void )
{
    char buf[ MaxString ];
    char ident[ MaxString ];
    //! FIX Fehler 48
    Device->SetAngleStep( dStepWidth );
    if ( Device->GetAngleStep() == 0.0 )
    {
        MessageBeep( 0 );
        return FALSE;
    }
    //! speichert Kanal pro Winkel im Ini-File des Psd
    sprintf( buf, "%.5f", Device->GetAngleStep() );
    sprintf( ident, "Device%d", Device->GetId() );
    WritePrivateProfileString( ident, "AngleStep", buf, GetCFile() );
    return TRUE;
};

//! wird bei verlassen der dialogbox aufgerufen Rueckkehrcode immer true
BOOL TCalibratePsd::LeaveDialog( void )
{
    //! loescht alle TimerIdInformation + stoppen der messung
    //! FIX Fehler 49
    mSetValue( Width, dOldMotorWidth );
    KillTimer( GetHandle(), TimerIdInformation );
    Device->MeasureStop();
    Device->SetHost( NULL );
    return TRUE;
};

//*****************************************************************************
//******* Dialog zum Auswaehlen von Scan's ************************************
//*****************************************************************************
//! Konstruktor fuer nichtmodale Dialogbox ChooseScan
//! dabei wird zunaechst der Konstruktor fuer Dialogboxen mit dem String, der
//! die Ressource spezifiziert, aufgerufen
#ifdef GermanVersion
TChooseScan::TChooseScan( TAreaScan* ascan ) : TModelessDlg( "ChooseScan" )
#else
TChooseScan::TChooseScan( TAreaScan* ascan ) : TModelessDlg( "ChooseScanEng" )
#endif
{
    AScan = ascan;
    Report = AScan->ScanReport;
};

//! setzt Defaultwerte der Dialogbox bei Aufruf der Box
//! Rueckkehrcode immer true
BOOL TChooseScan::Dlg_OnInit( HWND hwnd, HWND hwndCtl, LPARAM )
{
    char buf[ MaxString ];

    //! anzahl der Kurven eintragen + Scrollbar initialisieren
    nMaxScan = lpDBase->GetCNumber() - 1;
    sprintf( buf, "%d", nMaxScan );
    SetDlgItemText( hwnd, id_Limit, buf );
    BarHandle = GetDlgItem( hwnd, id_Bar );
    SetScrollRange( BarHandle, SB_CTL, 0, nMaxScan, TRUE );
    FORWARD_WM_COMMAND( hwnd, cm_ParamSet, hwndCtl, 0, SendMessage );
    return ( TRUE );
};


//! behandelt Kommandos in der Dialogbox
void TChooseScan::Dlg_OnCommand( HWND hwnd, int id, HWND hwndCtl,
                                 UINT codeNotify )
{
    char buf[ MaxString ];
    float x, y, z;

    switch ( id )
    {
        //! Update-Button gedrueckt
    case id_CurveShow:
        //! Scannummer aus Dialogbox holen + diese Darstellen
        GetDlgItemText( hwnd, id_ScanNumber, buf, MaxString );
        lpDBase->SetCIdx( atoi( buf ) );
        FORWARD_WM_COMMAND( hwnd, cm_ParamSet, hwndCtl, 0, SendMessage );
        break;

        //! aktualisieren
    case cm_ParamSet:
        //! aktuelle Kurve in Maincurve + Dialogboxeintraege eintragen +
        //! Fenster neuzeichnen
        AScan->nActiveScan = lpDBase->GetCIdx();
        AScan->MainCurve = lpDBase->GetCurve( AScan->nActiveScan );
        sprintf( buf, "%d", AScan->nActiveScan );
        SetDlgItemText( hwnd, id_ScanNumber, buf );
        SetScrollPos( BarHandle, SB_CTL, nMaxScan - AScan->nActiveScan, TRUE );
        Report->SetPP( AScan->nActiveScan );
        Report->PGet( x, y, z );
        //! FIX Fehler 42
        sprintf( buf, "%.3f", x );
        SetDlgItemText( hwnd, id_Omega, buf );
        Curve = AScan->MainCurve;
        sprintf( buf, "%.3f", Curve->Max[ 1 ] );
        SetDlgItemText( hwnd, id_PeakIntensity, buf );
        AScan->UpdateWnd( 0 );
        break;

        //! behandelt OK und Abbruch
    default:
        TModelessDlg::Dlg_OnCommand( hwnd, id, hwndCtl, codeNotify );
    }
};

#pragma argsused
//! wird aufgerufen, wenn in der Dialogbox die linke Maustaste nach Druecken
//! wieder losgelassen wird (sinnvoll wenn Dialogbox waehrend eines Areascans
//! aktiv ist)
void TChooseScan::Dlg_OnLButtonUp( HWND hwnd, int, int, UINT )
{
    char buf[ MaxString ];

    //! aktualisiert Anzahl der Scans der Datenbasis + anpassen des Scrollbar
    nMaxScan = lpDBase->GetCNumber() - 1;
    sprintf( buf, "%d", nMaxScan );
    SetDlgItemText( hwnd, id_Limit, buf );
    BarHandle = GetDlgItem( hwnd, id_Bar );
    SetScrollRange( BarHandle, SB_CTL, 0, nMaxScan, TRUE );
    FORWARD_WM_COMMAND( hwnd, cm_ParamSet, 0, 0, SendMessage );
};

#pragma argsused
//! wird aufgerufen, wenn Scrollbar angeclickt wurde
void TChooseScan::Dlg_OnVScrollBar( HWND hwnd, HWND hwndCtl, UINT code,
                                    int pos )
{
    switch ( code )
    {
        //! click auf oberen Pfeil
    case SB_LINEUP:
        lpDBase->SetCIdx( AScan->nActiveScan + 1 );
        break;

        //! click auf unteren Pfeil
    case SB_LINEDOWN:
        lpDBase->SetCIdx( AScan->nActiveScan - 1 );
        break;

        //! anclicken + bewegen des Scrollschiebers
    case SB_THUMBPOSITION:
        lpDBase->SetCIdx( nMaxScan - pos );
        break;

        //! anclicken, obwohl endposition bereits erreicht
    case SB_ENDSCROLL:
        FORWARD_WM_COMMAND( hwnd, cm_ParamSet, 0, 0, SendMessage );
        break;

        //! anclicken oberhalb des schiebers
    case SB_PAGEUP:
        lpDBase->SetCIdx( AScan->nActiveScan + 10 );
        break;

        //! anclicken unterhalb des schiebers
    case SB_PAGEDOWN:
        lpDBase->SetCIdx( AScan->nActiveScan - 10 );
        break;
    }
};

//! wird aufgerufen beim druecken des OK-Buttons
//! Rueckkehrcode immer true
BOOL TChooseScan::CanClose( void )
{
    return TRUE;
};
//#############################################################################

//*****************************************************************************
//******* Dialog zum Setzen der AreaScan-Parameter ****************************
//*****************************************************************************

//! Konstruktor fuer Dialogeinstellungen AreaScan
//! dabei wird zunaechst der Konstruktor fuer Dialogboxen mit dem String, der
//! die Ressource spezifiziert, aufgerufen
#ifdef GermanVersion
TSetupAreaScan::TSetupAreaScan( TAreaScan* scan ) :
        TModalDlg( "AreaScanParameters" )
#else
TSetupAreaScan::TSetupAreaScan( TAreaScan* scan ) :
        TModalDlg( "AreaScanParametersEng" )
#endif
{
    //! einige Parameter vom AreaScan-fenster uebernehmen
    Scan = scan;
    nOmega = Scan->nOmega;
    nTheta = Scan->nTheta;
    Device = Scan->Device;
    nOldMotor = mlGetAxis();
    //! wenn ein PSD-det. verfuegbar ist, dann Wert fuer zusammenzufassende
    //! Kanaele setzen
    if ( Scan->bPsdDevice )
        Device->SetAddedChannels( Scan->nAddedChannels );
};

#pragma argsused
//! setzt Defaultwerte der Dialogbox bei Aufruf der Box
//! Rueckkehrcode immer true
BOOL TSetupAreaScan::Dlg_OnInit( HWND hwnd, HWND hwndCtl, LPARAM lParam )
{
    int i = 0 ;
    char buf[ MaxString ];

    //! FIX Fehler 74
    if(!mlIsAxisValid(Theta))
     Scan->eScanType=StandardScan;
    //! Werte fuer Checkboxen 'Save on Ready' und 'Using Absorber' setzen
    CheckDlgButton( hwnd, id_SaveOnReady, Scan->bSaveOnReady );
    CheckDlgButton( hwnd, id_AbsorberUsed, Scan->bAbsorberUsed );

    //! diverse Werte in Dialogbox setzen
    sprintf( buf, "%.1f", Scan->fMaxTime );
    SetDlgItemText( GetHandle(), id_MaxTime, buf );
    //! Fehler id_ThetaUnit existiert nicht
    mlSetAxis( nTheta );
    SetDlgItemText( GetHandle(), id_ThetaUnit, mGetAxisUnit() );
    mlSetAxis( nOmega );
    SetDlgItemText( GetHandle(), id_Unit, mGetAxisUnit() );
    sprintf( buf, mGetDF(), Scan->dOmegaMax );
    SetDlgItemText( GetHandle(), id_AngleMax, buf );
    sprintf( buf, mGetDF(), Scan->dOmegaMin );
    SetDlgItemText( GetHandle(), id_AngleMin, buf );
    sprintf( buf, "%lu", Scan->dwMaxCounts );
    SetDlgItemText( GetHandle(), id_MaxCounts, buf );
    CheckDlgButton( GetHandle(), id_Standard,
                    Scan->eSaveFormat == StandardFile );
    CheckDlgButton( GetHandle(), id_DIB_Format, Scan->eSaveFormat == Bitmap );
    //! aufnehmen aller verfuegbaren Detektoren in Combobox und vorauswahl des
    //! aktuell eingestellten Det.
    hDeviceList = GetDlgItem( GetHandle(), id_ChooseDevice );
    i = 0;
      while ( i <= lpDList->LastId() )
         ComboBox_AddString( hDeviceList, lpDList->DP( i++) ->Characteristic );
    ComboBox_SelectString( hDeviceList, 0 , Device->Characteristic );
    CheckDlgButton( hwnd, id_SaveContinuous, Scan->bSaveContinuous );
    //! FIX Fehler 38
    sprintf( buf, szOWF, Scan->dOmegaWidth );
    SetDlgItemText( hwnd, id_AngleWidth, buf );
    SetDlgItemText( hwnd, id_Catalog, Scan->szDataPath );
    sprintf( buf, "%.2lf", Scan->dMoveRelation );
            SetDlgItemText( hwnd, id_Relation, buf );
    //! bewirkt aufruf von Dlg_OnCommand mit den Kommandos cm_ParamSet und
    //! cm_SetupParameters
    FORWARD_WM_COMMAND( hwnd, cm_ParamSet, hwndCtl, 0, SendMessage );
    FORWARD_WM_COMMAND( hwnd, cm_SetupParameters, hwndCtl, 0, SendMessage );
    return TRUE;
};

//! behandelt Kommandos in der Dialogbox
void TSetupAreaScan::Dlg_OnCommand( HWND hwnd, int id, HWND hwndCtl,
                                    UINT codeNotify )
{
    char buf[ MaxString ];
    int idx;

    //! abhaengig von Dialogelement bzw. Kommando
    switch ( id )
    {
        //! initialisierung
    case cm_ParamSet:
         //! abhaengig vom Scantyp einige Dialogelemente sperren bzw. freigeben
        switch ( Scan->eScanType )
        {
        case Omega2ThetaScan:
            EnableWindow( GetDlgItem( hwnd, id_Relation ), TRUE );
            //! abhaengig ob PSD verfuegbar oder nicht Dialogelemente sperren
            //! bzw. freigeben
				//! FIX Fehler 53
				CheckDlgButton( GetHandle(), id_FixThetaAxis, FALSE );
				if ( Scan->bPsdDevice )
				{
					 //! FIX Fehler 59
					 EnableWindow( GetDlgItem( hwnd, id_MaxCounts ), FALSE);
					 //! FIX Fehler 55
					 EnableWindow( GetDlgItem( hwnd, id_AbsorberUsed ), TRUE );
					 EnableWindow( GetDlgItem( hwnd, id_FixThetaAxis ), TRUE );
					 EnableWindow( GetDlgItem( hwnd, id_ThetaWidth ), FALSE );
					 EnableWindow( GetDlgItem( hwnd, id_ThetaWindow ), FALSE );
					 Scan->nAddedChannels = Device->GetAddedChannels();
					 Device->SetAddedChannels( Scan->nAddedChannels );
					 sprintf( buf, "%.3f", Device->GetWidth() );
					 SetDlgItemText( hwnd, id_ThetaWidth, buf );
				}
				else
				{
					 //! FIX Fehler 59
					 EnableWindow( GetDlgItem( hwnd, id_MaxCounts ), TRUE);
					 //! FIX Fehler 55
					 EnableWindow(GetDlgItem(hwnd,id_AbsorberUsed),FALSE);
                CheckDlgButton(hwnd,id_AbsorberUsed,FALSE);
                //! FIX Fehler 53
                EnableWindow( GetDlgItem( hwnd, id_FixThetaAxis ), FALSE );
                EnableWindow( GetDlgItem( hwnd, id_ThetaWindow ), TRUE );
                EnableWindow( GetDlgItem( hwnd, id_ThetaWidth ), TRUE );
                sprintf( buf, szTWF, Scan->dThetaWindow );
                SetDlgItemText( hwnd, id_ThetaWindow, buf );
					 sprintf( buf, szTWF, Scan->dThetaWidth );
                SetDlgItemText( GetHandle(), id_ThetaWidth, buf );
            }
            break;

        case StandardScan:
				//! FIX Fehler 59
				EnableWindow( GetDlgItem( hwnd, id_MaxCounts ), FALSE);
				//! FIX Fehler 55
            EnableWindow( GetDlgItem( hwnd, id_AbsorberUsed ), TRUE );
            CheckDlgButton( GetHandle(), id_FixThetaAxis, TRUE );
            EnableWindow( GetDlgItem( hwnd, id_FixThetaAxis ), TRUE );
            EnableWindow( GetDlgItem( hwnd, id_ThetaWindow ), FALSE );
            EnableWindow( GetDlgItem( hwnd, id_ThetaWidth ), FALSE );
            EnableWindow( GetDlgItem( hwnd, id_Relation ), FALSE );
            Scan->nAddedChannels = Device->GetAddedChannels();
				Device->SetAddedChannels( Scan->nAddedChannels );
				sprintf( buf, "%.3f", Device->GetWidth( mGetUnitType() ) );
				SetDlgItemText( hwnd, id_ThetaWidth, buf );
				sprintf( buf, szTWF, Scan->dThetaWindow );
            SetDlgItemText( hwnd, id_ThetaWindow, buf );
            break;

        default:
            MessageBox( GetFocus(), szMsgLine015, szMsgFailure, MBSTOP );
            break;
        }
        //! Focus auf OK-Button der Box
        SetFocus( GetDlgItem( hwnd, IDOK ) );
        break;

        //! 'Update Parameters'-Button betaetigt
    case cm_SetupParameters:
        FORWARD_WM_COMMAND( hwnd, cm_InquireRelevantData, hwndCtl, 0,
                            SendMessage );
        FORWARD_WM_COMMAND( hwnd, cm_ParamSet, hwndCtl, 0, SendMessage );
        break;

        //! uebernehmen von einigen Dialogeintraegen ohne pruefung (fehler)
		  //! 'Data Catalog','Save each Scan',Omegaschrittweite,Thetarelation,
		  //! Speicherformat
	 case cm_InquireRelevantData:
		  GetDlgItemText( GetHandle(), id_Catalog, ( LPSTR ) Scan->szDataPath,
								MaxString );
		  Scan->bSaveContinuous = IsDlgButtonChecked( GetHandle(),
										  id_SaveContinuous );
		  // Bestimmen der Schrittweite und Schrittrelation
		  GetDlgItemText( GetHandle(), id_AngleWidth, buf, MaxString );
		  Scan->dOmegaWidth = atof( buf );
		  GetDlgItemText( GetHandle(), id_Relation, buf, MaxString );
		  Scan->dMoveRelation = atof( buf );
		  //! uebernahme von Scantyp und abhaengig davon weitere werte
		  switch ( Scan->eScanType )
		  {
		  case Omega2ThetaScan:
				if ( Scan->bPsdDevice )
				{
					 if ( IsDlgButtonChecked( GetHandle(), id_FixThetaAxis ) )
					 {
						  Scan->eScanType = StandardScan;
						  break;
					 }
					 sprintf( buf, szTWF, Scan->dMoveRelation * Scan->dOmegaWidth );
					 SetDlgItemText( GetHandle(), id_ThetaWidth, buf );
				}
				else
				{
					 GetDlgItemText( GetHandle(), id_ThetaWindow, buf, MaxString );
					 Scan->dThetaWindow = atof( buf );
					 GetDlgItemText( GetHandle(), id_ThetaWidth, buf, MaxString );
					 Scan->dThetaWidth = atof( buf );
				}
				break;

		  case StandardScan:
				if ( !IsDlgButtonChecked( GetHandle(), id_FixThetaAxis ) )
				{
					 Scan->eScanType = Omega2ThetaScan;
					 if ( Scan->bPsdDevice )
					 {
						  sprintf( buf, szTWF, Scan->dMoveRelation * Scan->dOmegaWidth );
						  SetDlgItemText( GetHandle(), id_ThetaWidth, buf );
					 }
				}
				break;

		  default:
				MessageBox( GetFocus(), szMsgLine015, szMsgFailure, MBSTOP );
				break;
		  }
		  Scan->eSaveFormat = StandardFile;
		  if ( IsDlgButtonChecked( GetHandle(), id_DIB_Format ) )
				Scan->eSaveFormat = Bitmap;
		  if ( IsDlgButtonChecked( GetHandle(), id_Standard ) )
				Scan->eSaveFormat = StandardFile;
		  break;

		  //! Detektor-auswahlbox angewaehlt
	 case id_ChooseDevice:
		  switch ( codeNotify )
		  {
				//! wenn neuer det. ausgewaehlt, dann diesen als aktuellen Det.
				//! setzen und neuinitialisierung (cm_ParamSet)
		  case CBN_SELCHANGE:
				idx = ComboBox_GetCurSel( hDeviceList );
				if ( ( Device != lpDList->DP( idx ) ) && ( idx != CB_ERR ) )
				{
					 Device = lpDList->DP( idx );
					 Scan->SetDevice( Device->GetId() );
               //! FIX Fehler 74
                if(!mlIsAxisValid(Theta) && !Scan->bPsdDevice)
                 {
                 Scan->SetDevice( dlGetIdByName(PsdDevice));
                 Device= lpDList->DP(dlGetIdByName(PsdDevice));
                 ComboBox_SelectString( hDeviceList, 0, Device->Characteristic );
                 }
                else
                 if( Scan->bPsdDevice)
                  Scan->eScanType = StandardScan;
                 else
                  Scan->eScanType = Omega2ThetaScan;
					 FORWARD_WM_COMMAND( hwnd, cm_ParamSet, hwndCtl, 0, PostMessage );
				}
		  }
		  break;

		  //! 'Device Settings'-Button betaetigt
		  //! bewirkt Aufruf der zum eingestellten Detekt. gehoerigen Settingsbox
		  //! und uebernahme der akt. Einstellungen ohne pruefung
	 case cm_SpecificParameters:
		  // spezifische Parameter fuer einen Sensor setzen
		  if ( Scan->bPsdDevice )
		  {
				TheModeless = ( TPsdParameters * ) new TPsdParameters();
				if ( TheModeless )
					 TheModeless->Initialize();
		  }
		  else
				Device->SetSpezificParametersDlg();
		  FORWARD_WM_COMMAND( GetHandle(), cm_SetupParameters, 0, 0, SendMessage );
		  break;
       //! FIX Fehler 74
   case id_FixThetaAxis:
      if (!mlIsAxisValid(Theta))
       CheckDlgButton(GetHandle(),id_FixThetaAxis,TRUE);

		  //! anclicken der folgenden Dialogelemente bewirkt uebernahme der akt.
		  //! Einstellungen ohne pruefung

	 case id_DIB_Format:
	 case id_Standard:
		  FORWARD_WM_COMMAND( GetHandle(), cm_SetupParameters, 0, 0, PostMessage );
		  break;

	 //! FIX Fehler 71
	 case id_SaveContinuous: CheckDlgButton(GetHandle(),id_SaveOnReady,FALSE);
										break;
	 case id_SaveOnReady:    CheckDlgButton(GetHandle(),id_SaveContinuous,FALSE);
										break;
		  //! hier werden IDOK und IDCANCEL ... behandelt
	 default:
		  TModalDlg::Dlg_OnCommand( hwnd, id, hwndCtl, codeNotify );
	 }
};

//! realisiert test der Dialogboxinhalte auf ihre konsistenz vor verlassen der
//! Dialogbox (durch OK-Button)
//! Rueckkehrcode false wenn die Dialogbox nicht geschlossen werden kann (werte
//! inkonsistent) sonst true
BOOL TSetupAreaScan::CanClose( void )
{
	 char buf[ MaxString ], dir[ MAXDIR ], drv[ MAXDRIVE ], name[ MAXFILE ],
	 ext[ MAXEXT ];
	 float valueF;
	 OFSTRUCT of;
	 long valueL;
	 int hFile;
	 BOOL bFailure = FALSE;

	 //! uebernehmen von einigen werten ohne pruefung
	 FORWARD_WM_COMMAND( GetHandle(), cm_SetupParameters, 0, 0, SendMessage );
	 //! uebernahme der CheckButtons 'Save on Ready' und 'Using Absorber'
	 Scan->bSaveOnReady = IsDlgButtonChecked( GetHandle(), id_SaveOnReady );
	 Scan->bAbsorberUsed = IsDlgButtonChecked( GetHandle(), id_AbsorberUsed );
	 //! uebernahme des Omega-Maximum mit Pruefung, ob der Wert kleiner als der
	 //! maximal erlaubte
	 //! wenn Wert nicht kleiner als der max. erlaubte dann auf
	 //! Max.Wert-Schrittweite setzen + Setzen des korrekten Wertes fuer
	 //! Theta-Window? (Fehler) + Box wird nicht verlassen
	 GetDlgItemText( GetHandle(), id_AngleMax, buf, MaxString );
	 valueF = atof( buf );
	 //! FIX Fehler 50,52
	 if ( (valueF < mlGetValue( nOmega, MaxDistance ))&&
			(valueF > mlGetValue( nOmega, MinDistance )))
		  Scan->dOmegaMax = valueF;
	 else
	 {
		  Scan->dOmegaMax = ( mlGetValue( nOmega, MaxDistance ) -
									 mlGetValue( nOmega, Width ) );
		  sprintf( buf, mGetDF(), Scan->dOmegaMax );
		  SetDlgItemText( GetHandle(), id_AngleMax, buf );
		  bFailure = TRUE;
	 }

	 //! uebernahme des Omega-Minimum mit Pruefung, ob der Wert groesser als der
	 //! maximal erlaubte
	 //! wenn Wert nicht groesser als der max. erlaubte dann auf
	 //! Min.Wert+Schrittweite setzen + Setzen des korrekten Wertes fuer
	 //! Minimum + Box wird nicht verlassen
	 GetDlgItemText( GetHandle(), id_AngleMin, buf, MaxString );
	 valueF = atof( buf );
	 //! FIX Fehler 50
	 if ((valueF < mlGetValue( nOmega, MaxDistance ))&&
		 ( valueF > mlGetValue( nOmega, MinDistance ) ))
		  Scan->dOmegaMin = valueF;
	 else
	 {
		  Scan->dOmegaMin = ( mlGetValue( nOmega, MinDistance ) +
									 mlGetValue( nOmega, Width ) );
		  sprintf( buf, mGetDF(), Scan->dOmegaMin );
		  SetDlgItemText( GetHandle(), id_AngleMin, buf );
		  bFailure = TRUE;
	 }
	//! FIX Fehler 50,52
	 if (Scan->dOmegaMin >= Scan->dOmegaMax)
	  {
		Scan->dOmegaMax = ( mlGetValue( nOmega, MaxDistance ) -
								  mlGetValue( nOmega, Width ) );
		sprintf( buf, mGetDF(), Scan->dOmegaMax );
		SetDlgItemText( GetHandle(), id_AngleMax, buf );
		Scan->dOmegaMin = ( mlGetValue( nOmega, MinDistance ) +
								  mlGetValue( nOmega, Width ) );
		sprintf( buf, mGetDF(), Scan->dOmegaMin );
		SetDlgItemText( GetHandle(), id_AngleMin, buf );
		bFailure = TRUE;
	  }
    //!FIX Fehler 60 
	 switch (Scan->eScanType){
	 case Omega2ThetaScan:if (!(Scan->bPsdDevice))
								 {
								  //! uebernahme des Theta-Window mit Pruefung, ob der
								  //! Wert groesser 0 wenn nicht, setzen auf
								  //! (OmegaMax-OmegaMin)*Relation + eintragen des
								  //! entsprechenden Wertes in Dlg.Box + Box wird nicht
								  //! verlassen
								  GetDlgItemText( GetHandle(), id_ThetaWindow, buf, MaxString );
								  valueF = atof( buf );
								 //! FIX Fehler 50
								 if ( valueF > 0 )
									  Scan->dThetaWindow = valueF;
								 else
								 {
								  Scan->dThetaWindow = ( Scan->dOmegaMax - Scan->dOmegaMin ) *
									  Scan->dMoveRelation;
								  sprintf( buf, szTWF, Scan->dThetaWindow );
								  SetDlgItemText( GetHandle(), id_ThetaWindow, buf );
								  bFailure = TRUE;
								 }

	 //! uebernahme der Theta-Schrittweite mit Pruefung, ob der Wert ungleich 0
	 //! (Fehler) wenn nicht, setzen auf OmegaSchrittweite*Relation + eintragen
	 //! des entsprechenden Wertes in Dlg.Box + Box wird nicht verlassen
									GetDlgItemText( GetHandle(), id_ThetaWidth, buf, MaxString );
									 valueF = atof( buf );
								 //! FIX Fehler 50
								 if ( valueF > 0 )
									  Scan->dThetaWidth = valueF;
								 else
								 {
								  Scan->dThetaWidth = Scan->dOmegaWidth * Scan->dMoveRelation;
								  sprintf( buf, mGetDF(), Scan->dThetaWidth );
								  SetDlgItemText( GetHandle(), id_ThetaWidth, buf );
								  bFailure = TRUE;
								 }
								 //! uebernahme der Messimpulse mit Pruefung, ob der Wert ungleich 0 (Fehler)
								 //! wenn nicht, wird Box wird nicht verlassen
								 GetDlgItemText( GetHandle(), id_MaxCounts, buf, MaxString );
								 valueL = atol( buf );
								 //! FIX Fehler 50
								 if ( 0 < valueL )
								 {
								  Scan->dwMaxCounts = valueL;
								 }
								 else
								  bFailure = TRUE;
							 }
	 default:;
	 }

	 //! uebernahme der Messzeit mit Pruefung, ob der Wert ungleich 0
	 //! wenn nicht, wird Box wird nicht verlassen
	 GetDlgItemText( GetHandle(), id_MaxTime, buf, MaxString );
	 valueF = atof( buf );
	 //! FIX Fehler 50
	 if ( 0.0 < valueF )
	 {
		  Scan->fMaxTime = valueF;
	 }
	 else
		  bFailure = TRUE;

	 //! uebernahme des Datenpfades, wenn er sich beschreiben laesst
	 //! ansonsten auf "C:\\" setzen + Box wird nicht verlassen
	 GetDlgItemText( GetHandle(), id_Catalog, ( LPSTR ) Scan->szDataPath,
						  MaxString );
	 // Testen, ob sich der Pfad auch beschreiben laesst
	 if ( Scan->szDataPath[ strlen( Scan->szDataPath ) - 1 ] != '\\' )
		  strcat( Scan->szDataPath, "\\" );
	 fnsplit( Scan->szDataPath, drv, dir, name, ext );
	 fnmerge( Scan->szDataPath, drv, dir, "check", "tmp" );
	 hFile = OpenFile( Scan->szDataPath, &of, OF_CREATE );
	 if ( -1 != hFile )
	 {
		  _lclose( hFile );
		  remove( Scan->szDataPath );
		  fnmerge( Scan->szDataPath, drv, dir, "", "" );
	 }
	 else
	 {
		  bFailure = TRUE;
		  strcpy( Scan->szDataPath, "c:\\" );
		  //! FIX Fehler 38
		  SetDlgItemText( GetHandle(), id_Catalog, Scan->szDataPath );
	 }
	  //! FIX Fehler 38,51
		  GetDlgItemText( GetHandle(), id_AngleWidth, buf, MaxString );
		  if ( atof( buf ) > 0 )
			 Scan->dOmegaWidth = atof( buf );
		  else
			 {
			 Scan->dOmegaWidth = mGetValue( Width );
			  bFailure = TRUE;
			 }
		  sprintf( buf, szOWF, Scan->dOmegaWidth );
		  SetDlgItemText( GetHandle(), id_AngleWidth, buf );
		  GetDlgItemText( GetHandle(), id_Relation, buf, MaxString );
		  if ((Scan->dMoveRelation = atof( buf ))<= 0)
			{
			Scan->dMoveRelation = 2;
			bFailure = TRUE;
			}
		  sprintf( buf, "%.2lf", Scan->dMoveRelation );
		  SetDlgItemText( GetHandle(), id_Relation, buf );
	 //! bei aufgetretenen Fehlern cm_ParamSet senden und Dialogbox nicht
	 //! schliessen
	 if ( bFailure )
	 {
		  PostMessage( GetHandle(), WM_COMMAND, ( WPARAM ) cm_ParamSet, 0l );
		  return FALSE;
	 }

	 return TRUE;
};

//! wird bei verlassen der Dlg.box aufgerufen (in dieser Dlg.box keine
//! Bedeutung) da auch geerbt
BOOL TSetupAreaScan::LeaveDialog( void )
{
	 return TRUE;
}

//*****************************************************************************
//******* Dialog fuer Data Aquisition ****************************************
//*****************************************************************************
//! Konstruktor fuer Dialogeinstellungen 'Aquisition'
//! dabei wird zunaechst der Konstruktor fuer Dialogboxen mit dem String, der
//! die Ressource spezifiziert, aufgerufen
#ifdef GermanVersion
TAquisition::TAquisition( void ) : TModalDlg( "Aquisition" )
#else
TAquisition::TAquisition( void ) : TModalDlg( "AquisitionEng" )
#endif
{
	 bAquisitionActive = FALSE;
};

#pragma argsused
//! eintragen von Defaultwerten fuer alle Elemente bei Aufruf der Dlg.Box
//! rueckkehrcode immer true
BOOL TAquisition::Dlg_OnInit( HWND hwnd, HWND hwndCtl, LPARAM lParam )
{
	 //! int i = 0;
	 char buf[ MaxString ];

	 //! Anzahl der Messpunkte
	 sprintf( buf, "%d", nLinePoints );
	 SetDlgItemText( GetHandle(), id_LinePoints, buf );
	 //! Umgebung
	 sprintf( buf, "%d", nEnvironment );
	 SetDlgItemText( GetHandle(), id_AddedPoints, buf );
	 sprintf( buf, "%s", DataFile );
	 SetDlgItemText( GetHandle(), id_FileName, buf );
	 //! ?
	 CheckDlgButton( GetHandle(), id_DX, bSetDXZero );
	 CheckDlgButton( GetHandle(), id_DY, bSetDYZero );
	 CheckDlgButton( GetHandle(), id_RL, bSetRLSave );
	 return TRUE;
};

//! hier werden IDOK und IDCANCEL behandelt
void TAquisition::Dlg_OnCommand( HWND hwnd, int id, HWND hwndCtl,
											UINT codeNotify )
{
	 TModalDlg::Dlg_OnCommand( hwnd, id, hwndCtl, codeNotify );
};

//! realisiert test der Dialogboxinhalte auf ihre konsistenz vor verlassen der
//! Dialogbox (durch OK-Button)
//! Rueckkehrcode false wenn die Dialogbox nicht geschlossen werden kann (werte
//! inkonsistent) sonst true
BOOL TAquisition::CanClose( void )
{
	 int value;
	 OFSTRUCT of;
	 char buf[ MaxString ];

	 //! Werte der CheckBoxen uebernehmen wenn nicht beide markiert, sonst 'dX=0'
	 //! auf unmarkiert setzen, CheckButtons neu setzen und Box nicht verlassen
	 bSetDXZero = IsDlgButtonChecked( GetHandle(), id_DX );
	 bSetDYZero = IsDlgButtonChecked( GetHandle(), id_DY );
	 bSetRLSave = IsDlgButtonChecked( GetHandle(), id_RL );
	 if ( bSetDXZero * bSetDYZero )
	 {
		  bSetDXZero = !bSetDYZero;
		  CheckDlgButton( GetHandle(), id_DX, bSetDXZero );
		  CheckDlgButton( GetHandle(), id_DY, bSetDYZero );
		  return FALSE;
	 }
	 //! uebernehmen der 'Umgebung', wenn Wert im Bereich von 0 bis 3 liegt, sonst
	 //! Wert auf entsprechende Grenze setzen + Wert in Box eintragen + Box nicht
	 //! verlassen
    GetDlgItemText( GetHandle(), id_AddedPoints, buf, MaxString );
    value = atoi( buf );
    nEnvironment = max( 0, min( 3, value ) );
    if ( value != nEnvironment )
    {
        sprintf( buf, "%d", nEnvironment );
        SetDlgItemText( GetHandle(), id_AddedPoints, buf );
        return FALSE;
    }
    //! uebernehmen der 'Messpunkte', wenn Wert im Bereich von 0 bis 1100 liegt,
    //! sonst Wert auf entsprechende Grenze setzen + Wert in Box eintragen + Box
    //! nicht verlassen
    GetDlgItemText( GetHandle(), id_LinePoints, buf, MaxString );
    value = atoi( buf );
    nLinePoints = max( 0, min( 1100, value ) );
    if ( value != nLinePoints )
    {
        sprintf( buf, "%d", nLinePoints );
        SetDlgItemText( GetHandle(), id_LinePoints, buf );
        return FALSE;
    }
    //! Test, ob angeg. Datei bereits existiert + evtl. Fehlermeldung
    //! anlegen der Datei
    GetDlgItemText( GetHandle(), id_FileName, DataFile, MaxString );
    // Testen, ob sich das File auch erzeugen laesst
    if ( HFILE_ERROR != OpenFile( DataFile, &of, OF_EXIST ) )
    {
        strcpy( buf, "File existiert bereits !\r\nueberschreiben ?" );
        if ( IDYES == MessageBox( GetFocus(), buf, szMessage, MBASK ) )
            goto Exit;
        else
            return FALSE;
    }
    //! Fehlermeldung bei Problemen beim Anlegen der Datei
    if ( HFILE_ERROR == OpenFile( DataFile, &of, OF_CREATE ) )
    {
        strcpy( buf, "Probleme beim Anlegen des File !" );
		  MessageBox( GetFocus(), buf, szMessage, MBINFO );
        return FALSE;
    }
    remove( DataFile );
    //! wenn alles erfolgreich Marke setzen + Info + DataAquisiton auf true
    //!setzen
Exit:
    bAquisitionActive = TRUE;
    //! ? evtl ueberfluessig
    nSetMarker = 0;
    SetInfo( "Bitte mit der Maus eine Linie festlegen." );
    return TRUE;
};

//! wird bei verlassen der Dlg.box aufgerufen (in dieser Dlg.box keine
//! Bedeutung) da auch geerbt
BOOL TAquisition::LeaveDialog( void )
{
    return TRUE;
};
// __LastLine__

