// (C) 1993, 1994 by Heiko Damerow
// MPG AG "Roentgenbeugung an Schichtstrukturen"
#ifndef __M_DEVCOM_H
#define __M_DEVCOM_H

//JP  *****************************************************************
//JP  Dieser Kommentar wird in einer spaeteren Version entfernt.
//JP  Der Sinn einiger #defines ist noch unklar, andere werden als
//JP  Code fuer Funktionsmodi von Detektoren genutzt.
//JP  #define F_START 200
//JP  #define F_STEP 201
//JP  #define F_STOP 202
//JP  #define F_INTERRUPT 203
//JP  #define F_RESTART 204
//JP  #define D_TimeCounting 301
#define D_ImpulseCounting 302
//JP  #define D_Intensimeter 303
//JP  #define D_Accumulation 304
//JP  #define D_GrabPicture 305
//JP  #define D_Histogram 306
#define D_DiffractionScan 307
//JP  #define D_PSDScan 308
//JP  #define D_RRRR 309
//JP  *****************************************************************

#if defined ( Build_Counters ) 
#define _COUNTERCLASS _export
#elif defined( Use_Counters ) 
#define _COUNTERCLASS _import
#else
#define _COUNTERCLASS
#endif

typedef struct
{
  WPARAM wpJumpTo;
  float fExposureTime;
  DWORD dwExposureCounts;
  float fFailure;
  int nFunctionId;
  BOOL bStaticFailure;
  int nAddedChannels;
}
TDSettings;

class __rtti _COUNTERCLASS TDevice
{
//JP  *****************************************************************
//JP  Dieser Kommentar wird in einer spaeteren Version entfernt.
//JP  Ich habe bei allen Funktionen, die im Klassendefinitionskoerper
//JP  vollstaendig definiert werden, das Schluesselwort inline
//JP  entfernt, da diese Funktionen ohnehin implizit inline sind.
//JP  *****************************************************************
    
	friend class TDList;
    friend class TCommonDevParam;
    friend class TCounterWindow;
    friend class TAreaScan;
  public:
    TDevice( void );
    virtual ~TDevice( void );
    virtual int Initialize( void );
    virtual int SetParameters( void ) { return 1; };
    virtual void SetAddedChannels( int ) {};
    virtual int GetAddedChannels( void ) { return 1; };
    virtual float GetMaximumIntensity( void ) { return 1.0; };
    virtual BOOL SetSound( void ) { return TRUE; };
    virtual float GetAngleRange( void ) { return 1.0; }
    virtual float GetAngleRange( TUnitType ) { return 1.0; }
    THardware GetHardware( void ) { return eHardware; };
    virtual int MeasureStart( void );
    virtual int MeasureStop( void );
    virtual int MeasureStopExternal( void ) { return 1; };
    int SetExposureValues( float, DWORD, float );
    void GetExposureValues( float&, DWORD&, float& );
    virtual void SetSpezificParametersDlg( void ) {};
    virtual int PollDevice( void );
    virtual int SingleStepMeasurement( int ) { return 0; };
    virtual int GetData( float& );
    virtual int GetData( TCurve& ) { return 0; };
    virtual int GetData( WORD*, WORD, WORD ) { return 0; };
    virtual UINT GetMaximumChannel( void ) { return 0; };
    virtual void SetAngleStep( float ) {};
    virtual float GetAngleStep( void ) { return 0.0; };
    virtual void SetSignalGrowUp( BOOL ) {};
    virtual BOOL IsSoftOverflow( void ) { return FALSE; };
    virtual BOOL IsHardOverflow( void ) { return FALSE; };
    virtual LPCSTR GetUnitStr( void ) { return ""; }
    virtual float GetWidth( void ) { return 1.0; };
    virtual float GetWidth( TUnitType ) { return 1.0; };
    virtual void SetDataType( TPsdDataType ) {};
    int GetId( void ) { return nDevId; };
    int IsOk( void ) { return bDeviceOk; };
    void UpdateDisplay( void );
    BOOL IsActive( void ) { return bDeviceActive; };
    void SetHost( HWND hwnd ) { hControlWnd = hwnd; };
    float GetSigma( void ) { return fSigma; };
    virtual BOOL PushSettings( void );
    virtual BOOL PopSettings( void );
    BOOL SelectMFunction( int mf ) { nFunctionId = mf; return TRUE; };
    int GetMFunction( void ) { return nFunctionId; };
    static CALLBACK EventHandler( UINT, UINT, DWORD, DWORD, DWORD );
    virtual BOOL InitializeEvent( HWND, int );

//JP  *****************************************************************
//JP  Diese Attribute muessten eigentlich mindestens protected sein.
//JP  Auf sie wird aber aus anderen Subsystemen direkt zugegriffen.
//JP  Bis zur Schaffung eines neuen Interfaces muessen sie also public
//JP  bleiben.
	BOOL bDeviceOpen; // Geraet ist in irgendeiner Form aktiv
    char Characteristic[ MaxString ];
    double dRealTime;
    BOOL bDataValid;
    float fIntensity;
//JP  *****************************************************************

//JP  *****************************************************************
//JP  Dieser Abschnitt wird in einer spaeteren Version entfernt.
//JP  Diese Attribute werden im Projekt nicht verwandt
//JP  int nPeakWindow; // in Prozent
//JP  int nPeakLevel; // in Prozent
//JP  BOOL bAnalysator;
//JP  BOOL bDiskriminator;
//JP  *****************************************************************

//JP  *****************************************************************
//JP  Dieser Abschnitt wird in einer spaeteren Version entfernt.
//JP  Attribute sind jetzt protected.
//JP  BOOL bSound;
//JP  BOOL bStaticFailure; // Mess-Fehler auf bestimmtem Wert halten
//JP  int nFunctionId;
//JP  float fSigma;
//JP  *****************************************************************

  protected:

//JP  *****************************************************************
//JP  Dieser Kommentar wird in einer spaeteren Version entfernt.
//JP  vorher: double CalcTime( DWORD );
	static double CalcTime( DWORD mssum) // const 
	{ return ( mssum/1000L + (mssum%1000) / 1000L ); };
//JP  *****************************************************************

	void SetDisplay( HWND hwnd ) { hDisplayWnd = hwnd; };
    HWND GetDisplay( void ) { return hDisplayWnd; };
    HWND hDisplayWnd;
    HWND hControlWnd;
    BOOL bDeviceActive;
    BOOL bDeviceOk;
    WPARAM wpJumpTo;
    DWORD dwElapsedTime, dwStartTime;
	BOOL bSound;
	BOOL bStaticFailure; // Mess-Fehler auf bestimmtem Wert halten
    UINT uAskTime;
    BOOL bDebug;
    HWND hWndFrame;
    TDSettings Settings;
    float fExposureTime;
    DWORD dwExposureCounts;
    float fFailure;
    THardware eHardware;
    int nFunctionId;
    float fSigma;

//JP  *****************************************************************
//JP  Dieser Kommentar wird in einer spaeteren Version entfernt.
//JP  Diese vier Hardware-Limits sind konstante Eigenschaften der
//JP  jeweiligen Hardware. Ihre Funktionalitaet sollte also eher
//JP  durch virtuelle Funktionen realisiert werden.
    DWORD dwLowerCountBound;
    DWORD dwUpperCountBound;
    float fLowerTimeBound;
    float fUpperTimeBound;
//JP  *****************************************************************

  private:
    static int nMaxId;
    int nDevId;
};

class __rtti _COUNTERCLASS TDList
{
//JP  *****************************************************************
//JP  Dieser Kommentar wird in einer spaeteren Version entfernt.
//JP  Ich habe bei allen Funktionen, die im Klassendefinitionskoerper
//JP  vollstaendig definiert werden, das Schluesselwort inline
//JP  entfernt, da diese Funktionen ohnehin implizit sind.
//JP  *****************************************************************

  public:
    TDList( int, HINSTANCE );
    ~TDList( void );
    TDevice* DP( void );
    TDevice* DP( int );
    TDeviceType ParsingAxis( LPSTR );
    BOOL SetDevice( int );
    BOOL IsValidId( int id ) { return ( ( id >= 0 )  && ( id <= nLastDevice ) ); };
    BOOL DeleteDevices( void );
//JP  *****************************************************************
//JP  Dieser Abschnitt wird in einer spaeteren Version entfernt.
//JP  CalibrateDlg wird im gesamten Projekt nicht verwendet.
//JP  void CalibrateDlg( TCurve& );
//JP  *****************************************************************
    int GetDevice( void ) { return nActiveDevice; };
    int LastId( void ) { return nLastDevice; };

    HINSTANCE GetModuleHandle( void ) { return hDInstance; };
    BOOL InitializeModule( void );
    BOOL SaveModuleSettings( void ) { return TRUE; };
    void SetParametersDlg( void );
    int GetIdByName( TDeviceType );
    BOOL IsDeviceValid( TDeviceType );
  private:
    int MD_Monitor;
    int MD_Encoder;
    int MD_Psd;
    int MD_Counter;
    int MD_Generic;
    HINSTANCE hDInstance;
    int nMaxNumber;
    int nLastDevice; // points the last device
    int nActiveDevice; // points the actual device
    TDevice** aDevice;
};

class TCounterWindow : public TMDIWindow
{
//JP  *****************************************************************
//JP  Dieser Kommentar wird in einer spaeteren Version entfernt.
//JP  Ich habe bei allen Funktionen, die im Klassendefinitionskoerper
//JP  vollstaendig definiert werden, das Schluesselwort inline
//JP  entfernt, da diese Funktionen ohnehin implizit inline sind.
//JP  *****************************************************************
	
	friend class TCounterShowParam;
  public:
    TCounterWindow( int DeviceId );
    ~TCounterWindow( );
    void Create( HWND hwnd );
    HCURSOR GetCursor( void ) { return LoadCursor( NULL, IDC_ARROW ); };
    BOOL bShowAsDigital;
    void SetupLogging( void );
  protected:
    BOOL bWriteLogFile;
    TScaleType eScaleType;
    float fMaxIntensity;
    TDevice* Sensor;
    void CounterSetRequest( LPARAM );
    void Size( HWND, WPARAM, LPARAM );
    void rButtonDown( LPARAM );
    void SetFocus( void );
    BOOL CanOpen( void );
    void lButtonDown( WPARAM, LPARAM );
    void Paint( HDC, PAINTSTRUCT * );
  private:
    BOOL bQuiteOpen;
    HGLOBAL hMemG;
#if defined( __FLAT__ ) 
    float *IField;
#else
    float _huge *IField;
#endif
    float fData;
    int nIdx;
    int nMaxBarIdx;
    HPEN hPen;
    HBRUSH hBrushWhite, hBrushBlack, hBrushRed, hBrushOC;
    float fThickness, fHight;
    BOOL SetTitle( void );
    BOOL bAnalogSwitchOn;
    BOOL bWindowWillBeOpen;
    LPCSTR ClassName() { return "MDevice"; };
    LPCSTR GetCharacteristic( void ) { return "Device"; };
};

class TCounterShowParam : public TModalDlg
{
//JP  *****************************************************************
//JP  Dieser Kommentar wird in einer spaeteren Version entfernt.
//JP  Ich habe bei allen Funktionen, die im Klassendefinitionskoerper
//JP  vollstaendig definiert werden, das Schluesselwort inline
//JP  entfernt, da diese Funktionen ohnehin implizit inline sind.
//JP  *****************************************************************

  public:
    TCounterShowParam( TCounterWindow* );
  private:
    TCounterWindow* CounterWnd;
    BOOL CanClose( void );
    BOOL Dlg_OnInit( HWND, HWND, LPARAM );
    BOOL LeaveDialog( void ) { return TRUE; };
};

typedef TDList FAR * LPDList;
typedef TDevice FAR * LPDevice;

#endif
// __M_DEVCOM_H
// __LastLine__
