#ifndef __M_JUSTAG_H
#define __M_JUSTAG_H

#include "matrix.h"
#include "transfrm.h"


// globale Variable: legt fest ob das JustageLog geschrieben wird
// definiert in m_justag.cpp
extern bool bWriteLogfile;

// globale Funktion um Statusmeldungen in das Logfile
// fr die Automatische Justage schreiben
void WriteToJustageLog(char* buf);

// Dialogklasse der Automatischen Justage
class TAutomaticAngleControl : public TModalDlg
{
 public:
           TAutomaticAngleControl();
  BOOL     Dlg_OnInit ( HWND, HWND, LPARAM );
  void     Dlg_OnCommand( HWND, int, HWND, UINT );
  BOOL     LeaveDialog(void);


 private:
  // Tranformationsobjekt als Member definiert
  TransformationClass *Transform;

  TDevice* Sensor;
  
  // Inhalt des Statusfeldes
  char * status;
  
  //Aktivierung der Abbruchkriteriums Intensittsdifferenz
  bool bIntensityDiffActive;
  
  // maximale Groesse fuer das Status-Textfeld
  unsigned nMaxString;
  
  // Temporre Buffer zur Stringzusammensetzung
  char *buf, *buf1;

  // Laufvariablen
  int durchlauf,step,step1,count;
  
  // Anzahl der Zeilen im Status-Textfeld
  DWORD dwStatusZeilen;
  
  // Zahl der durchzufhrenden Messungen pro Position
  unsigned nMeasureCount;
  
  // Positionsvariablen, Intensittsvariablen
  double fPosition, intervall_li, intervall_re, x,y,z,x2,y2,z2;
  double MaxTL,MaxDF,MaxCC;
  float fIntenseDifferenz;
  
  // Variablen zur Ausgabe der Justagedauer
  struct date datum;
  struct time zeit;
  int justageanfang, justageende, justagezeit;
  
  // Variablen zur Speicherung der Wertebereiche & Intensittspositionen
  TMotorPositionsWerte Wertebereich, aktWertebereich;
  TIntensityPosition MaxIntensity, LastIntensity, ActIntensity;
};

#endif
