// File m_topo.h
// (C) 1994 by Heiko Damerow MPG AG "Roentgenbeugung"
#ifndef _M_TOPO_H
#define _M_TOPO_H

class TTopographyExecute : public TModalDlg
{
 public:    
           TTopographyExecute( void );
  BOOL     Dlg_OnInit( HWND, HWND, LPARAM );
  void     Dlg_OnCommand( HWND, int, HWND, UINT );
  void     Dlg_OnTimer( HWND, UINT );
  BOOL     LeaveDialog( void ); 
 private:
  BOOL     bControlActive;
  BOOL     bSetupOk;
  BOOL     bStartPointOk;
  int      RestShots;
  BOOL     bStarted;
  BOOL     bTimeFinish;
  BOOL     bAdditionalTime;
  BOOL     bExeptionOccured;
  BOOL     bTimeRunning;
  DWORD    CurrentTime, StartTime;
  TDevice* Device;
  int      nMotor;
};

class TTopographySetParam : public TModalDlg
{
 public:
           TTopographySetParam( int );
  char     SensorList[7][30];
  BOOL     CanClose( void );
  void     Dlg_OnCommand( HWND, int, HWND, UINT );
  BOOL     Dlg_OnInit( HWND, HWND, LPARAM );
  BOOL     LeaveDialog( void );
 private:
  int      nRestrictions;
  HWND     hDeviceList, hMotorList;
  int      nMotor, nOldMotor;
  TDevice* Device;  //## Detektor
  TDevice* Monitor; 
};

class TTopography
{
  friend   TTopographyExecute;
  friend   TTopographySetParam;
 public:      
           TTopography( void );
  void     Initialize( void );
 protected:
  BOOL     bSmallAngleSide;
  // Klein-Winkel = TRUE
  WORD     nNumberCycle;       // Anzahl der Mess-Zyklen
  float    fWorkPoint;         // Arbeitspunkt
  float    fControlRange;      // Regel-Bereich nach Intensitaet
  float    fControlStep;       // Regel-Schrittweite
  float    fMoveStep;          // Schrittweite zum Anfahren des Arbeitspunktes
  float    fMaxAngleEscape;    // Bei Weglaufen der Regelung
  long     lMeasurementTime;   // Mess-Zeit in Sekunden je Zyklus
  int      nMotor;             // Regelmotor
  TDevice* Sensor;             // Messgeraet
  float    fFailure;           // Zur Konfiguration des Zaehlers
  float    fMaxTime;           // Maximale Messzeit
  DWORD    dwMaxCounts;        // Maximale Anzahl Impulse
  BOOL     bMonitorUsed;       // Flag fuer Monitor
  TDevice* Monitor;            // Zweiter Zaehler fuer Monitor-Signal
  BOOL     bMultibleShot;      // Mehrfach-Belichtungen
  double   dStartAngle;        // Startwinkel relativ zum Peak
  float    fAngleBetweenShots; // Abstand bei Mehrfachbelichtung
};

//*****************************************************************************
#endif  
// _M_TOPO_H
// __LastLine__
